var minhand = new Image (17, 53);
minhand.src = 'Zeiger/Minuten.pdf';

var sechand = new Image (9, 49);
sechand.src = 'Zeiger/Sekunden.pdf';

var hourhand = new Image (13, 27);
hourhand.src = 'Zeiger/Stunden.pdf';

var originalSeconds = 0;
var theSeconds = 0;
var oldMinutes = 0;
var timer = null;

var minutesAngle;
var hoursAngle;
var secondsAngle;

if (window.widget)
	{
		if(widget.preferenceForKey ("StaendigesUpdate") == "Aus")
			{
			widget.onhide = onhide;
			widget.onshow = onshow;
			}
		else
			{
			widget.onhide = onshow;
			widget.onshow = onshow;
			}
	}

function onshow() {
    startSecondHandTimer();
}

function onhide() {
	if (timer != null)
	{
	    clearInterval(timer);
	    timer = null;
	}
}

function clockLoaded() {
    startSecondHandTimer();
}

function startSecondHandTimer()
{
    if ( timer != null )
    {
		clearInterval( timer );
		timer = null;
    }
    timer = setInterval("updateTime();",1000);
}

function updateTime()
{
    var now = new Date();

    now.setTime(now.getTime());

    secondsAngle = now.getSeconds() * 0.10471975511965977;
    minutesAngle = now.getMinutes() * 0.10471975511965977;
    hoursAngle = ((now.getHours()%12) * 0.523598775598) + (minutesAngle/6.283185481853 * 0.523598775598);

    drawHands (hoursAngle, minutesAngle, secondsAngle);

	var today=now.getDate()
	document.getElementById("DatumText").innerText=today;
}

function drawHands (hoursAngle, minutesAngle, secondsAngle)
{
	var canvas = document.getElementById("canvas");
	var context = canvas.getContext("2d");
//Breite und Hoehe angeben
	context.clearRect (0, 0, 150, 150);

	context.save();
//Position des Zentrums
	context.translate (75, 75);

	context.save();
	context.rotate (secondsAngle);
	context.translate (-3.5,-50.5);
	context.drawImage (sechand, 0, 0, 7, 55);
	context.restore();

	context.save();
	context.rotate (hoursAngle);
	context.translate (-7, -28.5);
	context.drawImage (hourhand, 0, 0, 13, 27);
	context.restore();

	context.rotate (minutesAngle);
	context.translate (-8.5, -44);
	context.drawImage (minhand, 0, 0, 17, 53);

	context.restore();
}