function setup() {
	// a lot of prefs.
	if (window.widget) {
		var image = widget.preferenceForKey(makeKey('image'));
		if(image && image.length > 0) {
			getImage(image);
		}
		var title = widget.preferenceForKey(makeKey('title'));
		if(title && title.length > 0) {
			document.getElementById('titleBar').value = title
			setTitle(title);
		}
		var color = widget.preferenceForKey(makeKey('color'));
		if(color && color.length > 0) {
			colorIt(color);
		}
		var year = widget.preferenceForKey(makeKey('year'));
		if(year && year.length > 0) {
			document.getElementById('yearBar').value = year;
		}
		var month = widget.preferenceForKey(makeKey('month'));
		if(month && month.length > 0) {
			document.getElementById('monthBar').value = month;
		}
		var day = widget.preferenceForKey(makeKey('day'));
		if(day && day.length > 0) {
			document.getElementById('dayBar').value = day;
		}
		var hour = widget.preferenceForKey(makeKey('hour'));
		if(hour && hour.length > 0) {
			document.getElementById('hourBar').value = hour;
		}
		var tintOpacity = widget.preferenceForKey(makeKey('tintOpacity'));
		if(tintOpacity && tintOpacity.length > 0) {
			document.getElementById('tintSlider').value = tintOpacity;
			tntSlider(tintOpacity)
		}
		var fadeTitle = widget.preferenceForKey(makeKey('fadeTitle'));
		if(fadeTitle != undefined) {
			document.getElementById('fadeTitle').checked = fadeTitle;
		}
		var fadeCount = widget.preferenceForKey(makeKey('fadeCount'));
		if(fadeCount != undefined) {
			document.getElementById('fadeCount').checked = fadeCount;
		}
		var transparent = widget.preferenceForKey(makeKey('transparent'));
		if(transparent != undefined) {
			document.getElementById('transparentBox').checked = transparent;
			transBox();
		}
		var prevStatus = widget.preferenceForKey(makeKey('prevStatus'));
		if(prevStatus != undefined) {
			if (prevStatus == true) {
				prevOn()
			}
			if (prevStatus == false) {
				prevOff()
			}
		}
		else {
			prevOff()
		}
	}
	countup();
}
if (window.widget) {
    widget.onshow = onshow;
    widget.onhide = onhide;
}
function onshow() {
	ct = setTimeout("countup()",1000);
}
function onhide() {
	clearTimeout(ct);
}
function makeKey(key) {
	return widget.identifier + "-" + key;
}
function dragdrop (event) {
	var uri = null;
	try {
	    uri = event.dataTransfer.getData("text/uri-list");	
	} catch (ex)											
	{
	}
		
	if (uri)
	{
		if(window.widget)
		{
			widget.setPreferenceForKey(uri,makeKey('image'));
		}						
		alert(uri)
		document.getElementById('mainImage').src = uri;
	}															

	event.stopPropagation();
	event.preventDefault();
}

function dragenter (event)
{
	event.stopPropagation();
	event.preventDefault();
}

function dragover (event)
{
	event.stopPropagation();
	event.preventDefault();
}

function dragleave (event)
{
	event.stopPropagation();
	event.preventDefault();
}
var ct;
function countup() {
	if (document.getElementById('yearBar').value != '' && document.getElementById('monthBar').value != '' && document.getElementById('dayBar').value != '' && document.getElementById('hourBar').value != '') {
		var startyr = document.getElementById('yearBar').value;
		var startmo = document.getElementById('monthBar').value;
		var startda = document.getElementById('dayBar').value;
		var starth = document.getElementById('hourBar').value;
		var startmin = 0;
		var startsec = 0;
		var montharray = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec")
		
		var today = new Date();
		var todayy = today.getUTCFullYear();
		if (todayy < 1000){
			todayy += 1900;
		}
		var todaym = today.getMonth();
		var todayd = today.getDate();
		var todayh = today.getHours();
		var todaymin = today.getMinutes();
		var todaysec = today.getSeconds();
		var todaystring = montharray[todaym] + " " + todayd + ", " + todayy + " " + todayh + ":" + todaymin + ":" + todaysec;
		var startstring = montharray[startmo-1] + " " + startda + ", " + startyr + " " + starth + ":" + startmin + ":" + startsec;
	
		var dd = (Date.parse(startstring) - Date.parse(todaystring));
	
		dday = Math.floor(dd/(60*60*1000*24));
	
		dhour = Math.floor((dd%(60*60*1000*24))/(60*60*1000));
	
		dmin = Math.floor(((dd%(60*60*1000*24))%(60*60*1000))/(60*1000));
	
		dsec=Math.floor((((dd%(60*60*1000*24))%(60*60*1000))%(60*1000))/1000);
	
		dday = (dday < 0) ? 0 : dday;
		dhour = (dhour < 0) ? 0 : dhour;
		dmin = (dmin < 0) ? 0 : dmin;
		dsec = (dsec < 0) ? 0 : dsec;
		
		if (dsec < 10) {
			var dsec = '0'+dsec;
		}
		if (dmin < 10) {
			var dmin = '0'+dmin;
		}
		if (dhour < 10) {
			var dhour = '0'+dhour;
		}
		
		if (dday > 0 || dhour > 0 || dmin > 0 || dsec > 0) {
			document.getElementById('count').innerHTML = dday+ ':' +dhour+ ':' +dmin+ ':' +dsec;
		}
		if (dday <= 0 && dhour == 0 && dmin == 0 && dsec == 0) {
			document.getElementById('count').innerHTML = 'Event Happened';
		}
		
		ct = setTimeout("countup()",1000)
	}
	if (document.getElementById('yearBar').value == '' || document.getElementById('monthBar').value == '' || document.getElementById('dayBar').value == '' || document.getElementById('hourBar').value == '') {
		document.getElementById('count').innerHTML = 'Enter  a  Date';
	}
	if (isNaN(dday) == true || isNaN(dhour) == true || isNaN(dmin) == true || isNaN(dsec) == true) {
		document.getElementById('count').innerHTML = 'Error';
	}
}
function setTitle(value) {
	if (value.length <= 14) {
		document.getElementById('title').style.fontSize = '14px';
	}
	if (value.length == 15 || value.lenth == 16) {
		document.getElementById('title').style.fontSize = '12px';
	}
	if (value.length == 17  || value.lenth == 18 || value.length == 19  || value.length == 20) {
		document.getElementById('title').style.fontSize = '10px';
	}
	if (value.length > 20) {
		document.getElementById('title').style.fontSize = '8px';
	}
	document.getElementById('title').innerHTML = value;
	if(window.widget) {
		widget.setPreferenceForKey(value,makeKey('title'));
	}
}
function tntSlider(value) {
	if(window.widget) {
		widget.setPreferenceForKey(value,makeKey('tintOpacity'));
	}
	var newer = value / 100;
	document.getElementById('tint').style.opacity = newer;
}
function getImage(image) {
	document.getElementById('mainImage').src = image;	
}
function saveYear(value) {
	if(window.widget) {
		widget.setPreferenceForKey(value,makeKey('year'));
	}
}
function saveMonth(value) {
	if(window.widget) {
		widget.setPreferenceForKey(value,makeKey('month'));
	}
}
function saveDay(value) {
	if(window.widget) {
		widget.setPreferenceForKey(value,makeKey('day'));
	}
}
function saveHour(value) {
	if(window.widget) {
		widget.setPreferenceForKey(value,makeKey('hour'));
	}
}
function savefadeTitle() {
	if(window.widget) {
		widget.setPreferenceForKey(document.getElementById('fadeTitle').checked,makeKey('fadeTitle'));
	}
}
function savefadeCount() {
	value = document.getElementById('fadeCount').checked;
	if(window.widget) {
		widget.setPreferenceForKey(value,makeKey('fadeCount'));
	}
}
function transBox() {
	if (document.getElementById('transparentBox').checked) {
		document.getElementById('well').style.backgroundImage = 'url("images/well_2.png")';
	}
	else {
		document.getElementById('well').style.backgroundImage = 'url("images/well_1.png")';
	}
	if(window.widget) {
		widget.setPreferenceForKey(document.getElementById('transparentBox').checked,makeKey('transparent'));
	}
}

//		switching stuff
//

function otherClick() {
	document.getElementById('other').style.display = 'block';
	document.getElementById('date').style.display = 'none';
	document.getElementById('colors').style.display = 'none';
	document.getElementById('otherButton').src = 'images/buttons/other_selected.png';
	document.getElementById('dateButton').src = 'images/buttons/date.png';
	document.getElementById('colorsButton').src = 'images/buttons/colors.png';
}
function dateClick() {
	document.getElementById('date').style.display = 'block';
	document.getElementById('other').style.display = 'none';
	document.getElementById('colors').style.display = 'none';
	document.getElementById('otherButton').src = 'images/buttons/other.png';
	document.getElementById('dateButton').src = 'images/buttons/date_selected.png';
	document.getElementById('colorsButton').src = 'images/buttons/colors.png';
}
function colorsClick() {
	document.getElementById('colors').style.display = 'block';
	document.getElementById('other').style.display = 'none';
	document.getElementById('date').style.display = 'none';
	document.getElementById('otherButton').src = 'images/buttons/other.png';
	document.getElementById('dateButton').src = 'images/buttons/date.png';
	document.getElementById('colorsButton').src = 'images/buttons/colors_selected.png';
}
function otherOver() {
	if (document.getElementById('other').style.display == 'none') {
		document.getElementById('otherButton').src = 'images/buttons/other_over.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('date').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other_over.png';
		document.getElementById('dateButton').src = 'images/buttons/date_selected.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('colors').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other_over.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors_selected.png';
	}
	if (document.getElementById('other').style.display == '') {
		document.getElementById('otherButton').src = 'images/buttons/other_over.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
}
function dateOver() {
	if (document.getElementById('date').style.display == 'none') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date_over.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('other').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other_selected.png';
		document.getElementById('dateButton').src = 'images/buttons/date_over.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('colors').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date_over.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors_selected.png';
	}
	if (document.getElementById('date').style.display == '') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date_over.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
}
function colorsOver() {
	if (document.getElementById('colors').style.display == 'none') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors_over.png';
	}
	if (document.getElementById('other').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other_selected.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors_over.png';
	}
	if (document.getElementById('date').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date_selected.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors_over.png';
	}
	if (document.getElementById('colors').style.display == '') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors_over.png';
	}
}
function otherOut() {
	if (document.getElementById('other').style.display == 'none') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('date').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date_selected.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('colors').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors_selected.png';
	}
	if (document.getElementById('other').style.display == '') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
}
function dateOut() {
	if (document.getElementById('date').style.display == 'none') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('other').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other_selected.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('colors').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors_selected.png';
	}
	if (document.getElementById('date').style.display == '') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
}
function colorsOut() {
	if (document.getElementById('colors').style.display == 'none') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('other').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other_selected.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('date').style.display == 'block') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date_selected.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
	if (document.getElementById('colors').style.display == '') {
		document.getElementById('otherButton').src = 'images/buttons/other.png';
		document.getElementById('dateButton').src = 'images/buttons/date.png';
		document.getElementById('colorsButton').src = 'images/buttons/colors.png';
	}
}
function prevOn(event) {
	document.getElementById('on').style.color = '#2E8DE5';
	document.getElementById('off').style.color = 'white';
	if(window.widget) {
		widget.setPreferenceForKey(true,makeKey('prevStatus'));
	}
	document.getElementById('previews').style.display = 'block';
}
function prevOff() {
	document.getElementById('off').style.color = '#2E8DE5';
	document.getElementById('on').style.color = 'white';
	if(window.widget) {
		widget.setPreferenceForKey(false,makeKey('prevStatus'));
	}
	document.getElementById('previews').style.display = 'none';
}
function prevIt(color,event) {
	document.getElementById(color+'Preview').style.display = 'block';
	var x = event.x
	var y = event.y
	document.getElementById(color+'Preview').style.left = x+10 +'px';
	document.getElementById(color+'Preview').style.top = y-50+'px';
	window.resizeTo(215, 165)
}
function prevItOff(color) {
	document.getElementById(color+'Preview').style.display = 'none';
	window.resizeTo(165, 165)
}
function colorIt(color) {
	document.getElementById('mainbody').style.backgroundImage = "url('images/main/main_"+color+".png')";
	if(window.widget) {
		widget.setPreferenceForKey(color,makeKey('color'));
	}
	var cs = document.getElementById('selector').style;
	if (color == 'aqua') {
		cs.top = '80px';
		cs.left = '91px';
		document.getElementById('flip').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_i.png)';
		document.getElementById('fliprollie').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_rollie.png)';
	}
	if (color == 'yellow') {
		cs.top = '24px';
		cs.left = '11px';
		document.getElementById('flip').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_i.png)';
		document.getElementById('fliprollie').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_rollie.png)';
	}
	if (color == 'white') {
		cs.top = '51px';
		cs.left = '51px';
		document.getElementById('flip').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/black_i.png)';
		document.getElementById('fliprollie').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/black_rollie.png)';
	}
	if (color == 'green') {
		cs.top = '80px';
		cs.left = '11px';
		document.getElementById('flip').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_i.png)';
		document.getElementById('fliprollie').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_rollie.png)';
	}
	if (color == 'red') {
		cs.top = '24px';
		cs.left = '91px';
		document.getElementById('flip').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_i.png)';
		document.getElementById('fliprollie').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_rollie.png)';
	}
	if (color == 'daqua') {
		cs.top = '80px';
		cs.left = '51px';
		document.getElementById('flip').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_i.png)';
		document.getElementById('fliprollie').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_rollie.png)';
	}
	if (color == 'default') {
		cs.top = '24px';
		cs.left = '51px';
		document.getElementById('flip').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_i.png)';
		document.getElementById('fliprollie').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_rollie.png)';
	}
	if (color == 'black') {
		cs.top = '51px';
		cs.left = '91px';
		document.getElementById('flip').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_i.png)';
		document.getElementById('fliprollie').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_rollie.png)';
	}
	if (color == 'orange') {
		cs.top = '51px';
		cs.left = '11px';
		document.getElementById('flip').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_i.png)';
		document.getElementById('fliprollie').style.backgroundImage = 'url(file:///System/Library/WidgetResources/ibutton/white_rollie.png)';
	}
}

