﻿//=======================变量设置======================

//配制变量
var transSet, viewStatues, cityJing, cityWei, wholeRing, alarmSet;

//所在地的经纬度和南北半球
var default_cityJing = 121+29/60, default_cityWei = 31+14/60;  //上海

var default_wholeRing = 30; //符号表示是否设置整点闹铃

//日出日落变量
var sun, today_sunrise, today_sunset;

//子界面高度
var Sizes = new Array (22, 156, 97, 437, 107, 12); 

//渐变动画变量
var face;
var flipper;
var sm1;
var smflipper;

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};

var resizeAnimation = {startTime:0, duration:500, positionFrom:0, positionTo:0, positionNow:0, frameFrom:0, frameTo:0, frameNow:0, timer:null, element:null, elementId: null, onfinished:null};

//时间变量
var date = new Date();
var olddate = date;
var currentMonth = date.getMonth();
var currentYear = date.getFullYear();
var currentDate = date.getDate();
var nhour = date.getHours();
var nmin = date.getMinutes();
var second;
var clock;
var updateclock = true;

//日历选择
var selectedDateID = idFromMonthDate (currentMonth, currentDate);

//定时器
var clockTimer = null;
var ringTimer = null;

//模拟钟变量
var	originalSeconds = 0;
var minutesAngle;
var hoursAngle;
var taijiAngle;
var minhand = new Image (17, 53);
var sechand = new Image (7, 55);
var hourhand = new Image (13, 27);

sechand.src = 'Images/secs.pdf';

//闹钟设置
var currentButton = "";
var buttonDown = false;
var selectedText = "alarm_hour";
var clockSelected = false;
var ring_duration, wt_duration;

//农历变量
var cYear, cMonth, c8Month, cDate, cDay, cShu, cCXQD, cLeap;
var ccDate;
var CNDATE = new Array("初一","初二","初三","初四","初五","初六","初七","初八","初九","初十", "十一","十二","十三","十四","十五","十六","十七","十八","十九","二十", "廿一","廿二","廿三","廿四","廿五","廿六","廿七","廿八","廿九","三十");
var CNMON = new Array("正","二","三","四","五","六","七","八","九","十","冬","腊");
var GAN = new Array("甲","乙","丙","丁","戊","己","庚","辛","壬","癸");
var ZHI = new Array("子","丑","寅","卯","辰","巳","午","未","申","酉","戌","亥");
var SHU = new Array("鼠","牛","虎","兔","龙","蛇","马","羊","猴","鸡","狗","猪");
var ConstellationName = new Array("白羊座", "金牛座", "双子座", "巨蟹座", "狮子座", "处女座", "天秤座", "天蝎座", "射手座", "摩羯座", "水瓶座", "双鱼座");
var solarTerm = new Array("小寒", "大寒", "立春", "雨水", "惊蛰", "春分", "清明", "谷雨", "立夏", "小满", "芒种", "夏至", "小暑", "大暑", "立秋", "处暑", "白露", "秋分", "寒露", "霜降", "立冬", "小雪", "大雪", "冬至");
var cCXQDs=new Array('孟春','仲春','季春','孟夏','仲夏','季夏','孟秋','仲秋','季秋','孟冬','仲冬','季冬');

var WXs = new Array("金", "金", "火", "火", "木", "木", "土", "土", "金", "金", "火", "火", "水", "水", "土", "土", "金", "金", "木", "木", "水", "水", "土", "土", "火", "火", "木", "木", "水", "水", "金", "金", "火", "火", "木", "木", "土", "土", "金", "金", "火", "火", "水", "水", "土", "土", "金", "金", "木", "木", "水", "水", "土", "土", "火", "火", "木", "木", "水", "水");

var lunarInfo = new Array(0x4BD8, 0x4AE0, 0xA570, 0x54D5, 0xD260, 0xD950, 0x16554, 0x56A0, 0x9AD0, 0x55D2,
    0x4AE0, 0xA5B6, 0xA4D0, 0xD250, 0x1D255, 0xB540, 0xD6A0, 0xADA2, 0x95B0, 0x14977,
    0x4970, 0xA4B0, 0xB4B5, 0x6A50, 0x6D40, 0x1AB54, 0x2B60, 0x9570, 0x52F2, 0x4970,
    0x6566, 0xD4A0, 0xEA50, 0x6E95, 0x5AD0, 0x2B60, 0x186E3, 0x92E0, 0x1C8D7, 0xC950,
    0xD4A0, 0x1D8A6, 0xB550, 0x56A0, 0x1A5B4, 0x25D0, 0x92D0, 0xD2B2, 0xA950, 0xB557,
    0x6CA0, 0xB550, 0x15355, 0x4DA0, 0xA5D0, 0x14573, 0x52D0, 0xA9A8, 0xE950, 0x6AA0,
    0xAEA6, 0xAB50, 0x4B60, 0xAAE4, 0xA570, 0x5260, 0xF263, 0xD950, 0x5B57, 0x56A0,
    0x96D0, 0x4DD5, 0x4AD0, 0xA4D0, 0xD4D4, 0xD250, 0xD558, 0xB540, 0xB5A0, 0x195A6,
    0x95B0, 0x49B0, 0xA974, 0xA4B0, 0xB27A, 0x6A50, 0x6D40, 0xAF46, 0xAB60, 0x9570,
    0x4AF5, 0x4970, 0x64B0, 0x74A3, 0xEA50, 0x6B58, 0x55C0, 0xAB60, 0x96D5, 0x92E0,
    0xC960, 0xD954, 0xD4A0, 0xDA50, 0x7552, 0x56A0, 0xABB7, 0x25D0, 0x92D0, 0xCAB5,
    0xA950, 0xB4A0, 0xBAA4, 0xAD50, 0x55D9, 0x4BA0, 0xA5B0, 0x15176, 0x52B0, 0xA930,
    0x7954, 0x6AA0, 0xAD50, 0x5B52, 0x4B60, 0xA6E6, 0xA4E0, 0xD260, 0xEA65, 0xD530,
    0x5AA0, 0x76A3, 0x96D0, 0x4BD7, 0x4AD0, 0xA4D0, 0x1D0B6, 0xD250, 0xD520, 0xDD45,
    0xB5A0, 0x56D0, 0x55B2, 0x49B0, 0xA577, 0xA4B0, 0xAA50, 0x1B255, 0x6D20, 0xADA0);
    
var gLunarHolDay = new Array(0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0x96, 0x96, 0x97, 0x87, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x87, 0x96, 0x87, 0x87, 0x79, 0x69, 0x69, 0x69, 0x78, 0x78,
    0x86, 0xA5, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0x96, 0x96, 0x97, 0x97, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x87, 0x96, 0x87, 0x87, 0x79, 0x69, 0x69, 0x69, 0x78, 0x78,
    0x86, 0xA5, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0x96, 0x96, 0x97, 0x97, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x87, 0x96, 0x87, 0x87, 0x79, 0x69, 0x69, 0x69, 0x78, 0x78,
    0x86, 0xA5, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x95, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x97, 0x96, 0x97, 0x87, 0x79, 0x79, 0x69, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA6, 0x96, 0x97, 0x78, 0x79, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x79, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA5, 0x97, 0x96, 0x97, 0x87, 0x79, 0x79, 0x69, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x78, 0x79, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x79, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0x96, 0x96, 0x97, 0x87, 0x79, 0x79, 0x69, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x78, 0x79, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0x96, 0x96, 0x97, 0x87, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0x96, 0x96, 0x97, 0x87, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0x96, 0x96, 0x97, 0x97, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0x96, 0x96, 0x97, 0x97, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0x96, 0x96, 0x97, 0x97, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0x96, 0xA5, 0xA6, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x78, 0x69, 0x78, 0x77,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0xA6, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x79, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x78, 0x79, 0x78, 0x69, 0x78, 0x77,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x79, 0x79, 0x79, 0x69, 0x78, 0x78,
    0x96, 0xA5, 0xA6, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x78, 0x79, 0x78, 0x68, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA5, 0xA5, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0xA5, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x96, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0xA5, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0xA5, 0xA5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x79, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0xA5, 0xA5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB5, 0x96, 0xA5, 0xA6, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x97, 0x97, 0x78, 0x79, 0x78, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0xA5, 0xB5, 0xA6, 0xA6, 0x88, 0x89, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x78, 0x87,
    0x96, 0xB4, 0x96, 0xA6, 0x96, 0x97, 0x78, 0x79, 0x78, 0x69, 0x78, 0x77,
    0x96, 0xA4, 0xA5, 0xB5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x78, 0x79, 0x78, 0x69, 0x78, 0x77,
    0x96, 0xB4, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0xA6, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x79, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x86,
    0xA5, 0xB4, 0xA5, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x86, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x76, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xA5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xA5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xA5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x69, 0x78, 0x87,
    0x96, 0xB4, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x87, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xB5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x78, 0x87,
    0x96, 0xB4, 0xA5, 0xB5, 0xA5, 0xA6, 0x87, 0x88, 0x87, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0x96, 0xA5, 0x96, 0x97, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0xA5, 0xB4, 0xA5, 0xA6, 0x87, 0x88, 0x87, 0x78, 0x87, 0x86,
    0xA5, 0xC3, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0xA6, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0xA5, 0xB4, 0xA5, 0xA6, 0x97, 0x87, 0x87, 0x78, 0x87, 0x86,
    0xA5, 0xC3, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x86,
    0xA5, 0xB4, 0xA5, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x79, 0x77, 0x87,
    0x95, 0xB4, 0xA5, 0xB4, 0xA5, 0xA6, 0x97, 0x87, 0x87, 0x78, 0x87, 0x96,
    0xA5, 0xC3, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xA5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0xA5, 0xB4, 0xA5, 0xA6, 0x97, 0x87, 0x87, 0x78, 0x87, 0x96,
    0xA5, 0xC3, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xA5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0x96, 0x96, 0x88, 0x78, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0xA5, 0xB4, 0xA5, 0xA6, 0x97, 0x87, 0x87, 0x78, 0x87, 0x96,
    0xA5, 0xC3, 0xA5, 0xB5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xA5, 0xA6, 0xA6, 0x88, 0x78, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0xA5, 0xB4, 0xA5, 0xA6, 0x97, 0x87, 0x87, 0x78, 0x87, 0x96,
    0xA5, 0xC3, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xA5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0xA5, 0xB4, 0xA5, 0xA6, 0x97, 0x87, 0x87, 0x78, 0x87, 0x96,
    0xA5, 0xC3, 0xA5, 0xB5, 0xA5, 0xA6, 0x87, 0x88, 0x87, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xB5, 0xA6, 0xA6, 0x88, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0xA5, 0xB4, 0xA5, 0xA6, 0x97, 0x87, 0x87, 0x88, 0x87, 0x96,
    0xA5, 0xC3, 0xA5, 0xB4, 0xA5, 0xA6, 0x87, 0x88, 0x87, 0x78, 0x87, 0x86,
    0xA5, 0xB3, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x88, 0x78, 0x87, 0x87,
    0xA5, 0xB4, 0x96, 0xA5, 0xA6, 0x96, 0x88, 0x88, 0x78, 0x78, 0x87, 0x87,
    0x95, 0xB4, 0xA5, 0xB4, 0xA5, 0xA5, 0x97, 0x87, 0x87, 0x88, 0x86, 0x96,
    0xA4, 0xC3, 0xA5, 0xA5, 0xA5, 0xA6, 0x97, 0x87, 0x87, 0x78, 0x87, 0x86,
    0xA5, 0xC3, 0xA5, 0xB5, 0xA6, 0xA6, 0x87, 0x88, 0x78, 0x78, 0x87, 0x87);

//月相变量
var mnnames = new Array("新(朔)月", "既朔月", "娥眉新月", "娥眉新月", "娥眉月", "夕月", "上弦月", "上弦月", "九夜月", "宵月", "宵月", "宵月", "渐盈凸月", "小望月", "满(望)月", "既望月", "立待月", "居待月", "寝待月", "更待月", "渐亏凸月", "下弦月", "下弦月", "有明月",  "有明月", "娥眉残月", "娥眉残月", "残月", "晓月", "晦月");
var moonimgs = new Array(1, 2, 3, 3, 4, 5, 6, 7, 8, 9, 9, 10, 11, 12, 13, 13, 14, 15, 16, 17, 18, 19, 19, 20, 21, 22, 22, 23, 24, 24);
var mnname, moonimg, cmoonimg;

//公历节日定义(两位数月+两位数日+空格+节日说明)
var CDAY = new Array(
	"0101 元旦",
	"0214 情人节",
	"0308 国际妇女节",
	"0312 植树节",
	"0315 消费者权益日",
	"0323 世界气象日",
	"0401 愚人节",
	"0422 世界地球日",
	"0501 国际劳动节",
	"0504 中国青年节",
	"0508 世界红十字日",
	"0512 国际护士节",
	"0517 世界电信日",
	"0531 世界无烟日",
	"0601 国际儿童节",
	"0605 世界环境日",
	"0623 奥林匹克日",
	"0625 全国土地日",
	"0626 世界禁毒日",
	"0701 中国共产党诞辰",
	"0711 世界人口日",
	"0801 建军节",
	"0903 抗战胜利日",
	"0908 国际扫盲日",
	"0910 教师节",
	"1001 国庆节",
	"1009 世界邮政日",
	"1016 世界粮食日",
	"1112 孙中山诞辰",
	"1117 国际学生节",
	"1220 澳门回归纪念日",
	"1225 圣诞节",
	"1226 毛泽东诞辰"
);

//=======================月份第几个星期几节日定义(两位数月份+第几个星期+星期几+空格+节日说明)
var CDAY2 = new Array(
	"0526 母亲节",
	"0636 父亲节"
);

//===========================农历节日定义(两位数月+两位数日+空格+节日说明)	
var CNDAY = new Array(
	"0101 春节",
	"0115 元宵",
	"0505 端午",
	"0707 七夕",
	"0815 中秋",
	"0909 重阳",
	"1208 腊八",
	"1223 小年",
	"1230 除夕"
);

//============================================== 启动程序 =============================================

//启动程序
function onLoaded()
{
	if(window.widget)
	{
		widget.onhide = onhide;
		widget.onshow = onshow;
		widget.onremove = onremove;
		
		transSet = loadKey("transSet");
		viewStatues = loadKey("viewStatues");
		cityJing = loadKey("cityJing");
		cityWei = loadKey("cityWei");
		wholeRing = loadKey("wholeRing");
		alarmSet = loadKey("alarmSet");
	}

		if (transSet == undefined)
			transSet = -1.0;
		if (viewStatues == undefined)
			viewStatues = 0x0f;
		if (cityJing == undefined)
			cityJing = default_cityJing;
		if (cityWei == undefined)
			cityWei = default_cityWei;
		if (wholeRing == undefined)
			wholeRing = default_wholeRing;
		if (alarmSet == undefined)
			alarmSet = 0;

		face = getEI("all");
		sm1 = getEI("sm1");
		clock = getEI("clock");
		flipper = new Fader(face, null, 2000);
		smflipper = new Fader(sm1, null, 2000);
		smflipper.fadingIn = false;
		
		face.style.opacity = Math.abs(transSet);
		
		if (alarmSet & 0x2000)
		{
			getEI("ring").src = "Images/ring_pressed.png";
		}
		else
			getEI("ring").src = "Images/ring.png";
		
		getEI("alarm_hour").innerHTML = formatNumber(((alarmSet & 0x1f00) >>> 8).toString());
		getEI("alarm_minute").innerHTML = formatNumber((alarmSet & 0xff).toString());
		
		if (cityJing < 0)
			getEI("jingOW").options[1].selected = true;
		else
			getEI("jingOW").options[0].selected = true;
		getEI("jingG").value = Math.abs(ipart(cityJing));
		getEI("jingF").value = Math.round(frac(cityJing)*60);
		
		if (cityWei < 0)
			getEI("weiNS").options[1].selected = true;
		else
			getEI("weiNS").options[0].selected = true;
		getEI("weiG").value = Math.abs(ipart(cityWei));
		getEI("weiF").value = Math.round(frac(cityJing)*60);
		
		if (wholeRing < 0)
			getEI("timeRING").options[1].selected = true;
		else
		{
			getEI("timeRING").options[0].selected = true;
			
		}
		getEI("alarmDUR").value = Math.abs(wholeRing);
		
		if (!(viewStatues & 0x04))
		{
			getEI("mid4").style.height = 0;
			Sizes[3] -= Sizes[4];
			getEI("ball_left").src="Images/ball_d.png";
		}
		if (!(viewStatues & 0x02))
		{
			getEI("mid2").style.height = 0;
			Sizes[3] -= Sizes[2];
			getEI("ball_mid").src="Images/ball_d.png";
		}
		if (!(viewStatues & 0x01))
		{
			getEI("mid1").style.height = 0;
			Sizes[3] -= Sizes[1];
			getEI("ball_right").src="Images/ball_d.png";
		}
		getEI("calMid").style.height = Sizes[3];

		if (!(viewStatues & 0x08))
		{
			getEI("calMid").style.height = 77;
			getEI("ball_left").style.visibility = "hidden";
			getEI("ball_mid").style.visibility = "hidden";
			getEI("ball_right").style.visibility = "hidden";
		}
		
		initialClock(true);
		
		var now = new Date(currentYear, currentMonth, currentDate, 12, 0, 0);
		lCal(now.getTime(), true);
//		BJTime();		
		setupMonth (currentMonth, currentYear);
		updateTiles ();
		hiliteToday ();
		startclock();
		clockTimer = setInterval('startclock()', 1000);
		if (viewStatues & 0x10)
		{
			flipper.doneNotification = thfade;
			flipper.fadetime = 5000;
			flipper.fadeOut();			
		}
		if (viewStatues & 0x20)
			showbackside (null);
}

function initialClock(iscal)
{
	if (iscal)
	{
		var tz = -(date.getTimezoneOffset())/60;
		var mj = mjd(currentDate, currentMonth+1, currentYear, 0.0);
		Cal(mj, tz, cityJing, cityWei, true);
	}
	
	var sm_now = nhour + nmin/100;		
	if (sm_now < today_sunrise || sm_now >= today_sunset)
		sun = true;
	else
		sun = false;
}

function onremove ()
{
	trashKey("transSet");
	trashKey("viewStatues");
	trashKey("cityJing");
	trashKey("cityWei");
	trashKey("wholeRing");
	trashKey("alarmSet");
}

function onshow ()
{
	viewStatues &= 0xbf;
	setTimeout('updateDate();',0);
	initialClock(false);
	updateclock = true;
	saveKey(viewStatues, "viewStatues");
}

function onhide () {
	if (!(viewStatues & 0xf0) && (viewStatues & 0x01))
		clearHands();
	viewStatues |= 0x40;
	saveKey(viewStatues, "viewStatues");
}

//===============================================操作函数==============================================

function getEI(key)
{
	return document.getElementById(key);
}

//设置的存取操作
function createKey (key)
{
	return widget.identifier + "-" + key;
}

function loadKey(key)
{
	return widget.preferenceForKey(createKey(key));
}

function saveKey(keyvalue, key)
{
	widget.setPreferenceForKey (keyvalue, createKey(key));
}

function trashKey(key)
{
	widget.setPreferenceForKey (null, createKey(key));
}

//格式化数字字符
function formatNumber(number)
{
	while (number.length < 2)
		number = "0" + number;
	return number;
}

//取小数
function frac(x) {
	var a;
	a = x - Math.floor(x);
	if (a < 0) a += 1;
	return a;
}

//取整
function ipart(x) {
	var a;
	if (x> 0) {
		a = Math.floor(x);
	}
	else {
		a = Math.ceil(x);
	}
	return a;
}



//===============================================日历函数===============================================

//=============================================日历的星期标题
function setupWeekHeader ()
{
	for (var i = 0;   i <= 6;   i++)
	{
		getEI ("dayofweek" + i).innerText = fetchIPrefNarrowDayOfWeekName (i);
	}
}

// JavaScript's Date.getDay() is Sunday-based, so we have to fix it up.
function getDayFromDate(date)
{
	var dayIndex = date.getDay() - fetchIPrefFirstWeekday();
	if (dayIndex < 0)
		dayIndex += 7;
	return dayIndex;
}


function idFromMonthDate(month, dateCount)
{
	return ((month<10) ? "0" + month : month.toString()) + 
	       ((dateCount<10) ? "0" + dateCount : dateCount.toString());
}

function fetchIPrefFirstWeekday () // returns integer
{
		return 1;
}

function fetchIPrefNarrowDayOfWeekName (inDayOfWeekIndex) // returns string
{
	var returnString = "x";
	
	switch (inDayOfWeekIndex)
	{
		case 0:   returnString = "一";   break;
		case 1:   returnString = "二";   break;
		case 2:   returnString = "三";   break;
		case 3:   returnString = "四";   break;
		case 4:   returnString = "五";   break;
		case 5:   returnString = "六";   break;
		case 6:   returnString = "日";   break;
	}
	return returnString;
}



function fetchIPrefShortMixedcaseDayOfWeekName (inDayOfWeekIndex)
{
	var returnString = "x";

	switch (inDayOfWeekIndex)
	{
		case 0:   returnString = "星期一";   break;
		case 1:   returnString = "星期二";   break;
		case 2:   returnString = "星期三";   break;
		case 3:   returnString = "星期四";   break;
		case 4:   returnString = "星期五";   break;
		case 5:   returnString = "星期六";   break;
		case 6:   returnString = "星期日";   break;
	}
	return returnString;
}

function dayClassFromDayIndex (inDay)
{
	switch (inDay)
	{
		case 0: return "sun";  break;
		case 1: return "mon";  break;
		case 2: return "tue";  break;
		case 3: return "wed";  break;
		case 4:	return "thur"; break;
		case 5: return "fri";  break;
		case 6: return "sat";  break;
	}
}

function fetchIPrefShortCapitalizedMonthName (inMonthIndex)
{
	var returnString = "x";
	switch (inMonthIndex)
	{
		case 0:    returnString = "1月";   break;
		case 1:    returnString = "2月";   break;
		case 2:    returnString = "3月";   break;
		case 3:    returnString = "4月";   break;
		case 4:    returnString = "5月";   break;
		case 5:    returnString = "6月";   break;
		case 6:    returnString = "7月";   break;
		case 7:    returnString = "8月";   break;
		case 8:    returnString = "9月";   break;
		case 9:    returnString = "10月";   break;
		case 10:   returnString = "11月";   break;
		case 11:   returnString = "12月";   break;
	}
	return returnString;
}

//=======绘制日历
function setupMonth(month, year)
{
	var mo = new Date(year, month, 1);
	var firstDay = getDayFromDate(mo);
	var monthDiv = getEI ("calendarDetail");
	var dayOfWeek = 0;
	var dateCount = 1;
	var rowCount = 0;
	
	// show the names of the days of the week
	setupWeekHeader ();
	
	// clear out the old
	if (monthDiv.hasChildNodes()) {
		var children = monthDiv.childNodes;
		var count = children.length;
		for(var j=0; j < count; j++) {
			monthDiv.removeChild(children[0]);
		}
	}
	
	// create the month
	for(var i=0; i< 48; i++)
	{
		var dateSpan = document.createElement("span");
	//设置日历每日的id并显示	
		if (dayOfWeek < firstDay) {
			dateSpan.innerHTML = "&nbsp;";
		} else {
			dateSpan.innerHTML = dateCount;
			dateSpan.setAttribute("id", idFromMonthDate(month, dateCount));
			dateCount++;
			mo.setDate(dateCount);
		}
		
		dateSpan.setAttribute("onmousedown", "selectDate(event, this.id);");
		dateSpan.setAttribute("onkeydown", "selectDate(event, this.id);");
		dateSpan.setAttribute("class", dayClassFromDayIndex(dayOfWeek%7));			
		monthDiv.appendChild(dateSpan);

		// increment the number of rows
		if (dayOfWeek%7 == 0)
			rowCount++;
		
		// stop after the number of days in this month
		if (mo.getMonth() != month)
			break;

		dayOfWeek++;
	}
	
	// tweak the row divider artwork
	var calDiv1 = getEI("calDiv1");
	var calDiv2 = getEI("calDiv2");
	
	if (rowCount == 5) {
		calDiv1.style.visibility = "visible";
		calDiv2.style.visibility = "hidden";
	} else if (rowCount == 6) {
		calDiv1.style.visibility = "visible";
		calDiv2.style.visibility = "hidden";
	} else {
		calDiv1.style.visibility = "hidden";
		calDiv2.style.visibility = "hidden";
	}
}

//================标亮今日
function hiliteToday() {
	if (!(viewStatues & 0xf0) && (viewStatues & 0x04))
	{
		var hilite = getEI("todayHilite");
		if ((currentMonth == date.getMonth()) && (currentYear == date.getFullYear()))
		{
			var c = getEI("calendar");
			var today = getEI(idFromMonthDate(currentMonth, date.getDate()));
			
			today.setAttribute("class", dayClassFromDayIndex(getDayFromDate(date)) + " today");
			hilite.style.visibility = "hidden";
			hilite.style.top = (today.offsetTop+c.offsetTop)-1+"px";
			hilite.style.left = today.offsetLeft+0+"px";
			hilite.style.visibility = "visible";
		}
		else
			hilite.style.visibility = "hidden";
	}
}

function hiliteDate (inDate)
{
	var hilite = getEI("dateHilite");
	
	if (inDate == "")
	{
		currentDate = 0;	// clear the selected date; don't parse empty string
	}
	else
	{
		currentDate = parseInt(inDate.substr(2,2),10);	// set the selected date
	}
	
	if ((idFromMonthDate(date.getMonth(), date.getDate()) == inDate) || (inDate==""))
	{
		// the hilite is over today's date.  hide it
		hilite.style.visibility = "hidden";
	} 
	else 
	{
		var c = getEI("calendar");
		var aDate = getEI(inDate);
		
		hilite.style.top = (aDate.offsetTop+c.offsetTop)+"px";
		hilite.style.left = aDate.offsetLeft+1+"px";
		hilite.style.visibility = "visible";
	}
	
//	updateTiles();
}

function jumpToToday (inEvent)
{
//	date = new Date();
	currentMonth = date.getMonth();
	currentYear = date.getFullYear();
	setupMonth(currentMonth, currentYear);
	if (viewStatues & 0x04)
	{
		hiliteDate(""); // clear selected date
		hiliteToday();
	}
	currentDate = date.getDate();
	updateTiles();
	selectedDateID = idFromMonthDate (currentMonth, currentDate);
}

function selectDate (inEvent, inID)
{
	hiliteDate (inID);
			
	selectedDateID = inID;
	
	updateTiles();
	inEvent.stopPropagation ();
	inEvent.preventDefault ();
}

//==================================================改变月份
function changeMonth(inEvent, inMoveNext)
{
	if (inMoveNext) {
		currentMonth++;
		if (currentMonth > 11) {
			currentYear++;
			currentMonth = 0;
		}
	} else {
		currentMonth--;
		if (currentMonth < 0) {
			currentYear--;
			currentMonth = 11;
		}
	}
	
	// create the new calendar
	setupMonth(currentMonth, currentYear);
	
	// set date selections as necessary
	hiliteToday();
	
	hiliteDate(""); // clear selected date

	selectedDateID = idFromMonthDate (currentMonth, currentDate); // note: will be invalid if currentDate is 0
	
	currentDate = 0; // clear the selected date
	
	updateTiles();
}

function updateDate() {
	var currentEqualDate = date.getMonth() == currentMonth &&
						  date.getFullYear() == currentYear &&
						  date.getDate() == currentDate;

	if (viewStatues & 0x01)
	{
		var tz = -(date.getTimezoneOffset())/60;
		var mj = mjd(date.getDate(), date.getMonth()+1, date.getFullYear(), 0.0);
		Cal(mj, tz, cityJing, cityWei, true);
	}
	
	if (currentEqualDate)
	{
		currentMonth = date.getMonth();
		currentYear = date.getFullYear();
		currentDate = date.getDate();
	}
	
	setupMonth(currentMonth, currentYear); 
	hiliteToday();
	updateTiles();
}

//==========================================显示和更新信息=============================
function updateTiles()
{
	var leftTopElement      = getEI ("day");
	var leftBottomElement   = getEI ("month");
	var leftElement         = getEI ("cyear");
	var rightTopElement		= getEI ("cdate");
	var rightElement        = getEI ("date");

	var tz = -(date.getTimezoneOffset()/60);
	
	var changeLeftTopStr    = undefined;
	var changeLeftBottomStr = undefined;
	var changeLeftStr		= undefined;
	var changeRightStr      = undefined;
	var changeRightTopStr = undefined;

	var changeBottomStr1 = undefined;
	var changeBottomStr2 = undefined;
	var changeBottomStr3 = undefined;
	var changeBottomStr4 = undefined;
	var changeBottomStr5 = undefined;
	var changeBottomStr = undefined;
	var currentmoonImg = undefined;
	var mj = undefined;
	var chinatime = undefined;
	var cityname = undefined;

	var lbTop = 0;
	if (!(viewStatues & 8) || !(viewStatues & 0x04)  || (!currentDate && (currentMonth == date.getMonth()) && (currentYear == date.getFullYear())))
	{
		var tyear = date.getFullYear();
		var tmonth = date.getMonth();
		var tdate = date.getDate();
		var now = new Date(tyear, tmonth, tdate, 12, 0, 0);
		lCal(now.getTime(), true);
		lbTop = 24;
		changeLeftTopStr = cYear + "年" + cShu;
		changeLeftBottomStr = fetchIPrefShortCapitalizedMonthName(tmonth);
		changeLeftStr = fetchIPrefShortMixedcaseDayOfWeekName(getDayFromDate(date));
		changeRightTopStr = cLeap + cMonth + "月" + ccDate;
		changeRightStr = tdate;
		rightElement.setAttribute("class", "tileCommon "+(((tdate>9) && (tdate<20))?"tileDateTight":"tileDate"));
		rightTopElement.setAttribute("class", "tileCommon tilecDate");
//		leftTopElement.setAttribute("class", "tileCommon tileDay");

		if (viewStatues & 0x02)
		{
			changeBottomStr2 = GetCDay(tmonth+1, tdate, getDayFromDate(date));
			changeBottomStr3 = ConstellationName[GetConstellationName(tmonth+1, tdate)];
			changeBottomStr = cYear + "年" + c8Month + "月" + cal8Day(tyear, tmonth+1, tdate) + "日";
			changeBottomStr5 = cCXQD + mnname;
			currentmoonImg = 'Images/moon/moon-' + cmoonimg +'.png';
		}
		if (viewStatues & 0x01)
		{
			changeBottomStr1 = GetJQ24(tyear, tmonth+1, tdate);
			changeBottomStr4 = cDay;
			mj = mjd(tdate, tmonth+1, tyear, 0.0);
			var chour = parseInt((nhour+1)/2);
			var temp = (nhour + 1) % 2;
			var cD;
			if (nhour == 23)
				cD = tdate + 1;
			else
				cD = tdate;
			chour = chour % 12;
			var num = cal8Daynum(tyear, tmonth+1, cD);
			chinatime = GAN[((num%10*2)%10+chour)%10] + ZHI[chour];
			if (temp == 0)
				chinatime = chinatime + "初";
			else
				chinatime = chinatime + "正";
			cityname = getLocalizedCityName (widget.closestCity());
		}
	}
	else
	{
		if (currentDate)
		{
			var aDate = new Date(currentYear, currentMonth, currentDate, 12, 0, 0);
			lCal(aDate.getTime(), false);
			lbTop = 24;
			changeLeftTopStr = cYear + "年" + cShu;
			changeLeftBottomStr = fetchIPrefShortCapitalizedMonthName(currentMonth);
			changeRightStr = currentDate;
			changeLeftStr = fetchIPrefShortMixedcaseDayOfWeekName(getDayFromDate(aDate));
			changeRightTopStr = cLeap + cMonth + "月" + cDate;
			rightElement.setAttribute("class", "tileCommon "+(((currentDate>9) && (currentDate<20))?"tileDateTight":"tileDate"));
			rightTopElement.setAttribute("class", "tileCommon tilecDate");

			if (viewStatues & 0x02)
			{
				changeBottomStr2 = GetCDay(currentMonth+1, currentDate, getDayFromDate(aDate));
				changeBottomStr3 = ConstellationName[GetConstellationName(currentMonth+1, currentDate)];
				changeBottomStr = cYear + "年" + c8Month + "月" + cal8Day(currentYear, currentMonth+1, currentDate) + "日";
				changeBottomStr5 = cCXQD + mnname;
			
				currentmoonImg = 'Images/moon/moon-' + moonimg +'.png';
			}

			if (viewStatues & 0x01)
			{
				changeBottomStr1 =  GetJQ24(currentYear, currentMonth+1, currentDate);
				changeBottomStr4 = cDay;
				mj = mjd(currentDate, currentMonth+1, currentYear, 0.0);
				var chour = parseInt((nhour+1)/2);
				var temp = (nhour + 1) % 2;
				var cD;
				if (nhour == 23)
					cD = currentDate + 1;
				else
					cD = currentDate;
				chour = chour % 12;
				var num = cal8Daynum(currentYear, currentMonth+1, cD);
				chinatime = GAN[((num%10*2)%10+chour)%10] + ZHI[chour];
				if (temp == 0)
					chinatime = chinatime + "初";
				else
					chinatime = chinatime + "正";
				cityname = getLocalizedCityName (widget.closestCity());
			}
		}
		else
		{
			var bDate = new Date(currentYear, currentMonth, 15, 12, 0, 0);
			lCal(bDate.getTime(), false);
			lbTop = 33;
			changeRightTopStr = cYear + "年" + cShu;
			changeLeftTopStr = "农历" + cLeap + cMonth + "月";
			changeLeftBottomStr = fetchIPrefShortCapitalizedMonthName(currentMonth);
			changeRightStr = currentYear;
			rightElement.setAttribute("class", "tileCommon tileSmallYear");
			rightTopElement.setAttribute("class", "tileCommon tileLcDate");
			
			if (viewStatues & 0x02)
			{
				changeBottomStr2 = "";
				changeBottomStr3 = "";
				changeBottomStr = "";
				changeBottomStr5 = "";
				currentmoonImg = "";
			}
			
			if (viewStatues & 0x01)
			{
				changeBottomStr4 = "";
				changeBottomStr1 = "";
				mj = "";
				var chour = parseInt((nhour+1)/2);
				var temp = (nhour + 1) % 2;
				chour = chour % 12;
				chinatime = ZHI[chour];
				if (temp)
					chinatime = chinatime + "正";
				else
					chinatime = chinatime + "初";
				cityname = getLocalizedCityName (widget.closestCity());
			}
		}
	}
	
	
	if (changeLeftBottomStr != undefined)		// typically the month name
	{
		leftBottomElement.style.visibility = "hidden";
		leftBottomElement.innerText = changeLeftBottomStr;
		leftBottomElement.style.width = "";
		leftBottomElement.style.setProperty ("font-size", "27px", "important");
		if (parseInt (document.defaultView.getComputedStyle (leftBottomElement, null).getPropertyValue ("width"), 10) > 65)
		{
			setFontSizeToFit (leftBottomElement, 27, lbTop, 65, 40);
		}
		else
		{
			leftBottomElement.style.width = 65;
			setFontSizeToFit (leftBottomElement, 27, lbTop, 65, 40);
		}
		leftBottomElement.style.visibility = "visible";
	}
	
	if (changeRightStr != undefined)			// either the date-in-month number or year-number
	{
		rightElement.style.visibility = "hidden";
		rightElement.innerText = changeRightStr;
		rightElement.style.visibility = "visible";
	}
	else
	{	
		rightElement.style.visibility = "hidden";
	}

	if (changeLeftStr != undefined)
	{		
		leftElement.style.visibility = "hidden";	
		leftElement.innerText = changeLeftStr;
		leftElement.style.visibility = "visible";
	}
	else
	{	
		leftElement.style.visibility = "hidden";	
	}
	
	if (changeRightTopStr != undefined)
	{
		rightTopElement.style.visibility = "hidden";	
		rightTopElement.innerText = changeRightTopStr;
		rightTopElement.style.visibility = "visible";
	}
	else
	{	
		rightTopElement.style.visibility = "hidden";	
	}

	if (changeLeftTopStr != undefined)			// typically the day name or nothing
	{
		leftTopElement.style.visibility = "hidden";
		leftTopElement.innerText = changeLeftTopStr;
		var lTTop = parseInt (document.defaultView.getComputedStyle (rightTopElement, null).getPropertyValue ("top"), 10);
		var lTfont = parseInt (document.defaultView.getComputedStyle (rightTopElement, null).getPropertyValue ("font-size"), 10);
		leftTopElement.style.width = "";
		leftTopElement.style.setProperty ("font-size", lTfont + "px", "important");
		if (parseInt (document.defaultView.getComputedStyle (leftTopElement, null).getPropertyValue ("width"), 10) > 55)
		{
			setFontSizeToFit (leftTopElement, lTfont, lTTop, 55, 40);
		}
		else
		{
			leftTopElement.style.width = 55;
			setFontSizeToFit (leftTopElement, lTfont, lTTop, 55, 40);
		}
		leftTopElement.style.visibility = "visible";
	}
	else
	{
		leftTopElement.style.visibility = "hidden";
	}

	if (changeBottomStr != undefined)
	{
		var BottomElement  = getEI ("constell");
		if (changeBottomStr != "")
		{
			BottomElement.style.visibility = "hidden";
			BottomElement.innerText = changeBottomStr;
			BottomElement.style.visibility = "visible";
		}
		else
		{
			BottomElement.style.visibility = "hidden";
		}
	}
	
	if (changeBottomStr1 != undefined)
	{
		var BottomElement1  = getEI ("constell1");
		if (changeBottomStr1 != "")
		{
			BottomElement1.style.visibility = "hidden";
			BottomElement1.innerText = changeBottomStr1;
		}
		else
			BottomElement1.innerText = "福海";
		BottomElement1.style.visibility = "visible";
	}
	
	if (changeBottomStr2 != undefined)
	{
		var BottomElement2  = getEI ("constell2");
		if (changeBottomStr2 != "")
		{
			BottomElement2.style.visibility = "hidden";
			BottomElement2.innerText = changeBottomStr2;
			BottomElement2.style.width = "";
			if (parseInt (document.defaultView.getComputedStyle (BottomElement2, null).getPropertyValue ("width"), 10) > 75)
			{
				setFontSizeToFit (BottomElement2, 12, 65, 90, 15);
			}
			else
			{
			BottomElement2.style.width = 75;
			setFontSizeToFit (BottomElement2, 12, 65, 75, 15);
			}
			BottomElement2.style.visibility = "visible";
		}
		else
			BottomElement2.style.visibility = "hidden";
	}

	if (changeBottomStr3 != undefined)
	{
		var BottomElement3  = getEI ("constell3");
		if (changeBottomStr3 != "")
		{
			BottomElement3.style.visibility = "hidden";
			BottomElement3.innerHTML = changeBottomStr3;
			BottomElement3.style.visibility = "visible";
		}
		else
			BottomElement3.style.visibility = "hidden";
	}

	if (changeBottomStr4 != undefined)
	{
		var BottomElement4  = getEI ("constell4");
		if (changeBottomStr4 != "")
		{
			BottomElement4.style.visibility = "hidden";
			BottomElement4.innerText = changeBottomStr4;
		}
		else
			BottomElement4.innerText = "寿山";			
		BottomElement4.style.visibility = "visible";
	}

	if (changeBottomStr5 != undefined)
	{
		var BottomElement5  = getEI ("constell5");
		if (changeBottomStr5 != "")
		{
			BottomElement5.style.visibility = "hidden";
			BottomElement5.innerText = changeBottomStr5;
			BottomElement5.style.visibility = "visible";
		}
		else
			BottomElement5.style.visibility = "hidden";
	}


	if (currentmoonImg != undefined)
	{
		var currentmoon  = getEI ("cmoon");
		if (currentmoonImg != "")
		{
			currentmoon.style.visibility = "hidden";
			currentmoon.src = currentmoonImg;
			currentmoon.style.visibility = "visible";
		}
		else	
			currentmoon.style.visibility = "hidden";
	}
	
	var chourE = getEI("chour");
	if (chinatime != undefined)
	{
		chourE.style.visibility = "hidden";
		chourE.innerText = chinatime;
		chourE.style.visibility = "visible";
	}
	else
		chourE.style.visibility = "hidden";
	
	var citynameE = getEI("cityname");
	if (cityname != undefined)
	{
		citynameE.style.visibility = "hidden";
		citynameE.innerText = cityname;
		
		citynameE.style.width = "";
		if (parseInt (document.defaultView.getComputedStyle (citynameE, null).getPropertyValue ("width"), 10) > 70)
		{
			setFontSizeToFit (citynameE, 12, 30, 70, 24);
		}
		else
		{
			citynameE.style.width = 70;
			setFontSizeToFit (citynameE, 12, 30, 70, 24);
		}		
		citynameE.style.visibility = "visible";
	}
	else
		citynameE.style.visibility = "hidden";

	if (mj != undefined)
	{
		var BottomElement6  = getEI ("constell6");
		if (mj != "")
		{
			BottomElement6.style.visibility = "hidden";
			BottomElement6.innerHTML = Cal(mj, tz, cityJing, cityWei, false);
			BottomElement6.style.visibility = "visible";
		}
		else
			BottomElement6.style.visibility = "hidden";
	}
}

function getLocalizedCityName (key)
{
	try {
		var value = localizedCityNames[key];
		if (value == null)
			value = "";
		return value;
	} catch (ex) {}

	return key;
}

//字体的动态调整
function setFontSizeToFit (inElement, inStartingFontSize, inStartingTop, inMaxWidth, inMaxHeight)
{
	var measuredWidth;
	var measuredHeight;
	var newFontSize = inStartingFontSize;
	var newTop = inStartingTop;
	
	while (1)
	{
		inElement.style.setProperty ("font-size", newFontSize + "px", "important");
		inElement.style.setProperty ("top", newTop + "px", "important");
		measuredWidth = parseInt (document.defaultView.getComputedStyle (inElement, null).getPropertyValue ("width"), 10);
		measuredHeight = parseInt (document.defaultView.getComputedStyle (inElement, null).getPropertyValue ("height"), 10);
		if ((measuredWidth > inMaxWidth) || (measuredHeight > inMaxHeight))
		{
			if (newFontSize <= 6)
			{
				break;
			}
			newFontSize -= 1;
			newTop += 0.75;
		}
		else
		{
			break;
		}
	}
}

//==================================农历计算============================================
//====================================== 传回农历 y年的总天数

function lYearDays(y){

	var i, sum = 348;

	for(i=0x8000; i>0x8; i>>=1) sum += (lunarInfo[y-1900] & i)? 1: 0;

	return(sum+leapDays(y));

}



//====================================== 传回农历 y年闰月的天数

function leapDays(y) {

   if(leapMonth(y))  return((lunarInfo[y-1900] & 0x10000)? 30: 29);

   else return(0);

}



//====================================== 传回农历 y年闰哪个月 1-12 , 没闰传回 0

function leapMonth(y) {

   return(lunarInfo[y-1900] & 0xf);

}



//====================================== 传回农历 y年m月的总天数

function monthDays(y,m) {

   return( (lunarInfo[y-1900] & (0x10000>>m))? 30: 29 );

}

//计算农历日期

function lCal(time, today){

	
	var i, leap=0, temp=0;

	//var baseDate = new Date(1900,0,31);

	var baseDate = -2206400400000;
	
	var offset   = (time - baseDate)/86400000;



	var dayCyl = offset + 40;

	var monCyl = 14;



	for(i=1900; i<2050 && offset>0; i++) {

      temp = lYearDays(i);

      offset -= temp;

      monCyl += 12;

   }



   if(offset<0) {

      offset += temp;

      i--;

      monCyl -= 12;

   }



   var nyear = i;

   var yearCyl = i-1864;



   leap = leapMonth(i); //闰哪个月

   var isLeap = false;



   for(i=1; i<13 && offset>0; i++) {

      //闰月

      if(leap>0 && i==(leap+1) && isLeap==false)

         { --i; isLeap = true; temp = leapDays(nyear); }

      else

         { temp = monthDays(nyear, i); }



      //解除闰月

      if(isLeap==true && i==(leap+1)) isLeap = false;



      offset -= temp;

      if(isLeap == false) monCyl ++;

   }



   if(offset==0 && leap>0 && i==leap+1)

      if(isLeap)

         { isLeap = false; }

      else

         { isLeap = true; --i; --monCyl;}



	if(offset<0){ offset += temp; --i; --monCyl; }

	cMonth = CNMON[i-1];
	cCXQD = cCXQDs[i-1];
	mnname = mnnames[Math.floor(offset)];
	cDay = GetCnDay(i,Math.floor(offset+1));
	cYear = GAN[yearCyl % 10] + ZHI[yearCyl % 12];
	cShu = WXs[yearCyl % 60] + SHU[(nyear-4)%12];
	c8Month = GAN[(((yearCyl % 10 + 1) * 2) % 10 + i-1) % 10] + ZHI[(i-1+2) % 12]; 
	cLeap = isLeap ? "闰" : "";
	
	if (!today)
	{
		cDate = CNDATE[Math.floor(offset)];
		moonimg = moonimgs[Math.floor(offset)];
	}
	else
	{
		ccDate = CNDATE[Math.floor(offset)];
		cmoonimg = moonimgs[Math.floor(offset)];	
	}
}

//'计算公历当天对应的节气 0-23，-1表示不是节气 
function GetJQ24(year,month,date){
	var Flag, Day, iYear, iMonth, iDay;
	iYear = year;

	if (iYear < 1901 || iYear > 2050)
		return "";
    
	iMonth = month;
	iDay = date;
	Flag = gLunarHolDay[(iYear - 1901) * 12 + iMonth - 1];
	if (iDay < 15)
		Day = 15 - ((Flag >> 4) & 0x0f);
	else
		Day = (Flag & 0x0f) + 15;
	
	if (iDay == Day)
	{
		if (iDay > 15)
			return  solarTerm[(iMonth - 1) * 2 + 1];
		else
			return solarTerm[(iMonth - 1) * 2];
	}
	else
		return "";
}

function cal8Day (year, month, day)
{
	 var num = cal8Daynum(year, month, day);
	 return(GAN[num%10]+ZHI[num%12]);
}

function cal8Daynum (year, month, day)
{
	 var num = Date.UTC(year,month-1,day,0,0,0,0)/86400000+25567+10;
	 return num;
}


//计算公历节日

function GetCDay(month,date,day){

	var str = "";
	
	for (i in CDAY)
	{
		if(CDAY[i].match(/^(\d{2})(\d{2})(\s)(.+)$/))
		{
			if(Number(RegExp.$1) == month && Number(RegExp.$2) == date)
            	str =  RegExp.$4;
		}
	}

	for (j in CDAY2)
	{
		if(CDAY2[j].match(/^(\d{2})(\d)(\d)(\s)(.+)$/))
		{
			if(Number(RegExp.$1) == month && (Number(RegExp.$2)-1)*7 < date 
				&& Number(RegExp.$2)*7 >= date && Number(RegExp.$3) == day)
			{
				str = str + RegExp.$5;
			}
		}
	}

	return str;
}

//计算农历节日

function GetCnDay(month,date){

	var str = "";
	for(i in CNDAY)
	{
    	if(CNDAY[i].match(/^(\d{2})(\d{2})(\s)(.+)$/))
    	{
    		if(Number(RegExp.$1) == month && Number(RegExp.$2) == date)
				str =  RegExp.$4;
		}
    }

	return str;
}

//计算自定义节日

function GetMyDay(month,date){

	var str = "";
	for(i in MyDAY)
	{
		if(MyDAY[i].match(/^(\d{2})(\d{2})(\s)(.+)$/))
		{
        	if(Number(RegExp.$1) == month && Number(RegExp.$2) == date)
            	str =  RegExp.$4;
		}
	}
	return str;
}

//计算星座
function GetConstellationName(month,day){

	var i = month + day/100;

	if(i> 3.2 && i<4.21)
		return 0;

	if(i>4.20 && i<5.22)
		return 1;

	if(i > 5.21 && i<6.22)
		return 2;

	if(i>6.21 && i<7.23)
		return 3;

	if(i>7.22 && i<8.24)
		return 4;

	if(i>8.23 && i<9.24)
		return 5;

	if(i>9.23 && i<10.24)
		return 6;

	if(i>10.23 && i<11.23)
		return 7;

	if(i>11.22 && i<12.22)
		return 8;

	if(i> 12.21 || i<1.21)
		return 9;
		
	if(i>1.20 && i<2.19)
		return 10;

	if(i>2.18 && i<3.21)
		return 11;
}

//=================================计算日出日落时间=================================
function Cal(mjd, tz, glong, glat, today) {

	var sglong, sglat, cglat, tdate, ym, yz, above, utrise, utset, j;
	var yp, nz, rise, sett, hour, z1, z2, iobj, rads = 0.0174532925;
	var quadout = new Array;
	var always_up = "无日落";
	var always_down = "无日出";
	var outstring = "";

	sinho = Math.sin(rads * -0.833);		
	sglat = Math.sin(rads * glat);
	cglat = Math.cos(rads * glat);
	tdate = mjd - tz/24;
	rise = false;
	sett = false;
	above = false;
	hour = 1.0;

	ym = sin_alt(2, tdate, hour - 1.0, glong, cglat, sglat) - sinho;
	
	if (ym > 0.0) above = true;
	while(hour < 25 && (sett == false || rise == false)) {
		yz = sin_alt(2, tdate, hour, glong, cglat, sglat) - sinho;
		yp = sin_alt(2, tdate, hour + 1.0, glong, cglat, sglat) - sinho;
		quadout = quad(ym, yz, yp);
		nz = quadout[0];
		z1 = quadout[1];
		z2 = quadout[2];
		xe = quadout[3];
		ye = quadout[4];
		if (nz == 1) {
			if (ym < 0.0) {
				utrise = hour + z1;
				rise = true;
			}
			else {
				utset = hour + z1;
				sett = true;
			}
		} 
		if (nz == 2) {
			if (ye < 0.0) {
				utrise = hour + z2;
				utset = hour + z1;
			}
			else {
				utrise = hour + z1;
				utset = hour + z2;
			}
		} 
		ym = yp;
		hour += 2.0;
	} 
	if (rise == true || sett == true ) {
		if (rise == true) outstring += '日出: ' + hrsmin(utrise); 
		else outstring += "日出: 无日出"+"  ";	
		if (sett == true) outstring += "<br>日落: " + hrsmin(utset);
		else outstring += " - 日落: 无日落";
		if (today){
			var hrs;
			hrs = Math.floor(utrise * 60 + 0.5)/ 60.0;
			var sunrisehour = Math.floor(hrs);
			var sunrisemin = Math.floor(60 * (hrs - sunrisehour) + 0.5);
			if (!rise)
				today_sunrise = 24;
			else
				today_sunrise = sunrisehour + sunrisemin/100;
			hrs = Math.floor(utset * 60 + 0.5)/ 60.0;
			var sunsethour = Math.floor(hrs);
			var sunsetmin = Math.floor(60 * (hrs - sunsethour) + 0.5);
			if(!sett)
				today_sunset = 24;
			else
				today_sunset = sunsethour + sunsetmin/100;			
		}	
	}
	else {
		if (above == true){
		 outstring += always_up;
		 if (today)
		 {
		 	today_sunrise = 0;
		 	today_sunset = 24;
		 }
		}
		else
		{
			outstring += always_down;
			 if (today)
			 {
			 	today_sunset = 0;
			 	today_sunrise = 24;
			 }
			
		}
	}		
	return outstring;
}

function sin_alt(iobj, mjd0, hour, glong, cglat, sglat) {
	var mjd, t, ra, dec, tau, salt, rads = 0.0174532925;
	var objpos = new Array;
	mjd = mjd0 + hour/24.0;
	t = (mjd - 51544.5) / 36525.0;
	
	if (iobj == 1) {
	} else {
		objpos = minisun(t);
	}
	
	ra = objpos[2];
	dec = objpos[1];
	tau = 15.0 * (lmst(mjd, glong) - ra);
	salt = sglat * Math.sin(rads*dec) + cglat * Math.cos(rads*dec) * Math.cos(rads*tau);
	return salt;
}

function minisun(t) {
	var p2 = 6.283185307, coseps = 0.91748, sineps = 0.39778;
	var L, M, DL, SL, X, Y, Z, RHO, ra, dec;
	var suneq = new Array;

	M = p2 * frac(0.993133 + 99.997361 * t);
	DL = 6893.0 * Math.sin(M) + 72.0 * Math.sin(2 * M);
	L = p2 * frac(0.7859453 + M / p2 + (6191.2 * t + DL)/1296000);
	SL = Math.sin(L);
	X = Math.cos(L);
	Y = coseps * SL;
	Z = sineps * SL;
	RHO = Math.sqrt(1 - Z * Z);
	dec = (360.0 / p2) * Math.atan(Z / RHO);
	ra = (48.0 / p2) * Math.atan(Y / (X + RHO));
	if (ra <0 ) ra += 24;
	suneq[1] = dec;
	suneq[2] = ra;
	return suneq;
}

function lmst(mjd, glong) {
	var lst, t, d;
	d = mjd - 51544.5
	t = d / 36525.0;
	lst = range(280.46061837 + 360.98564736629 * d + 0.000387933 *t*t - t*t*t / 38710000);
	return (lst/15.0 + glong/15);
}

function quad(ym, yz, yp) {
	var nz, a, b, c, dis, dx, xe, ye, z1, z2, nz;
	var quadout = new Array;

	nz = 0;
	a = 0.5 * (ym + yp) - yz;
	b = 0.5 * (yp - ym);
	c = yz;
	xe = -b / (2 * a);
	ye = (a * xe + b) * xe + c;
	dis = b * b - 4.0 * a * c;
	if (dis > 0)	{
		dx = 0.5 * Math.sqrt(dis) / Math.abs(a);
		z1 = xe - dx;
		z2 = xe + dx;
		if (Math.abs(z1) <= 1.0) nz += 1;
		if (Math.abs(z2) <= 1.0) nz += 1;
		if (z1 < -1.0) z1 = z2;
	}
	quadout[0] = nz;
	quadout[1] = z1;
	quadout[2] = z2;
	quadout[3] = xe;
	quadout[4] = ye;
	return quadout;
}


function range(x) {
	var a, b;
	b = x / 360;
	a = 360 * (b - ipart(b));
	if (a  < 0 ) {
		a = a + 360
	}
	return a
}

function hrsmin(hours) {
	var h, m, dum;
	h = ipart(hours);
	m = Math.round(60 * (hours - h));
	h = formatNumber(h.toString());
	m = formatNumber(m.toString());
	dum = h +"时"+ m +"分";
	return dum;
}


function mjd(day, month, year, hour) {
	var a, b;
	if (month <= 2) {
		month = month + 12;
		year = year - 1;
	}
	a = 10000.0 * year + 100.0 * month + day;
	if (a <= 15821004.1) {
		b = -2 * Math.floor((year + 4716)/4) - 1179;
	} else {
		b = Math.floor(year/400) - Math.floor(year/100) + Math.floor(year/4);
	}
	a = 365.0 * year - 679004.0;
	return (a + b + Math.floor(30.6001 * (month + 1)) + day + hour/24.0);
}

//=======================================钟面绘制====================================
//=================================清除钟面
function clearHands()
{
	var canvas =    getEI("canvas");
	var context = canvas.getContext("2d");
	
	context.clearRect (0, 0, 120, 120);
}

//======================绘制钟面
function drawHands (hoursAngle, minutesAngle, secondsAngle, taijiAngle)
{
	var canvas =    getEI("canvas");
	var context = canvas.getContext("2d");
	
	context.clearRect (0, 0, 120, 120);

	context.save();
	context.translate (120/2, 120/2);

	context.save();
	context.rotate (hoursAngle);
	context.translate (-7, -28.5);
	context.drawImage (hourhand, 0, 0, 13, 27);
	context.restore();
	
	context.save();
	context.rotate (minutesAngle);
	context.translate (-8.5, -44);
	context.drawImage (minhand, 0, 0, 17, 53);
	context.restore();

	context.rotate (secondsAngle);
	context.translate (-3.5,-50.5);
	context.drawImage (sechand, 0, 0, 7, 55);

	context.restore();
}

var preTz;
//=======================================时钟函数========================================
function startclock()
{
	date = new Date();
	var Tz = date.getTimezoneOffset()
	var difference = date - olddate;

	nhour = date.getHours();
	nmin = date.getMinutes();
	second = date.getSeconds();

	if (difference > 1500 || difference < 500 || Tz != preTz)
	{
		setTimeout('jumpToToday(null)',0);
		initialClock(true);
		updateclock = true;
	}

	if (!(nhour || nmin || second))
		setTimeout('jumpToToday(null)',0);
	
	olddate = date;
	preTz = Tz;
	if ((alarmSet & 0x2000) && !second)
	{
		if((nhour == (alarmSet & 0x1f00)>>>8) && (nmin == (alarmSet & 0x00ff))) 
		{
			if (ringTimer != null)
			{
				clearInterval (ringTimer);
				ringTimer = null;
			}
			ring_duration = Math.abs(wholeRing);
			alarmRing(ring_duration, true);
			ringTimer = setInterval("alarmRing(ring_duration,true);",1000);
		}
	}
						
	if ((wholeRing >= 0) && (ringTimer == null) && !nmin && !second)
	{
		wt_duration = nhour;
		wt_duration %= 12;
		if (!wt_duration)
			wt_duration = 12;
		alarmRing(wt_duration, false);
		ringTimer = setInterval('alarmRing(wt_duration,false)', 1000);
	}
	
	if (!(viewStatues & 0xe0) && (viewStatues & 0x11))
	{
		var sm = getEI("sm");
		var sm_now = nhour + nmin/100;
		if (sm_now < today_sunrise || sm_now >= today_sunset)
		{
			if (sun)
			{
				hourhand.src = 'Images/hour.pdf';
				minhand.src = 'Images/mins.pdf';
			
				sm.src = 'Images/moon/moon-' + cmoonimg +'.png';
				sm1.src = sm.src;
		
				sm.style.left = '137px';
				sm.style.top = '2px';
				sm1.style.left = '137px';
				sm1.style.top = '295px';
				sun = false;
			}
		}
		else
		{
			if (!sun)
			{
				hourhand.src = 'Images/pmhour.pdf';
				minhand.src = 'Images/pmmins.pdf';
		
				sm.src = 'Images/sun.png';
				sm1.src = sm.src;
		
				sm.style.left = '125px';
				sm.style.top = '-16px';
				sm1.style.left = '125px';
				sm1.style.top = '277px';
				sun = true;
			}
		}
	}
	
	if (!(viewStatues & 0xf0))
	{
		if (viewStatues & 0x01)
		{
			if (!nmin && !second)
			{
				var chour = parseInt((nhour+1)/2);
				var temp = (nhour + 1) % 2;
				var cD;
				var chinatime;
				chour %= 12;
				if (currentDate)
				{
					if (nhour == 23)
						cD = currentDate + 1;
					else
						cD = currentDate;
					var num = cal8Daynum(currentYear, currentMonth+1, cD);
					chinatime = GAN[((num%10*2)%10+chour)%10] + ZHI[chour];
				}
				else
					chinatime = ZHI[chour];
				if (!temp)
					chinatime = chinatime + "初";
				else
					chinatime = chinatime + "正";
				getEI("chour").innerText = chinatime;
				
			}
			
			originalSeconds = second;
		
			var secondsAngle = originalSeconds * 0.10471975511965977; // all angles computed in radians
			minutesAngle = nmin * 0.10471975511965977;
			hoursAngle = ((nhour%12) * 0.523598775598) + (minutesAngle/6.283185481853 * 0.523598775598);
			originalSeconds += 30;
			originalSeconds %= 60;
			taijiAngle = originalSeconds * 0.10471975511965977;
			drawHands (hoursAngle, minutesAngle, secondsAngle, taijiAngle);
		}
	
		if (viewStatues & 0x02 && (!second || updateclock))
		{
			BJTime();
			updateclock = false;
		}
	}
} 

function BJTime()
{
		var nhours = nhour;
		var pre = date.getTimezoneOffset()/60 + 8;
		nhours += pre + 24;
		nhours %= 24;
		var nmins;
		nmins = formatNumber(nmin.toString());
		nhours = formatNumber(nhours.toString());	
		if (pre>0 && nhours < pre)
			pre = "翌日";
		else if (pre < 0 && nhours >= (pre + 24))
			pre = "前日";
		else
			pre ="当日";
		var longtime = nhours + ":" + nmins;
		getEI("bjpre").innerHTML = pre;
		clock.innerText = longtime;
}

//==================================闹钟与报时=======================================
//=================================闹钟设置：选择时／分
function selectMe(event, div)
{
	selectedText = div;
	var divs = new Array("alarm_hour", "alarm_minute");
	var i = 0;
	var selected = "";
	for (i = 0; i <= 1; i++)
	{
		if (div == divs[i])
			selected = "_selected";
		else
			selected = "";
		getEI(divs[i]).className = "field_text" + selected;
	}
}

//=================================闹钟调整按钮

function buttonEvent(event, div, evt)
{
	switch (evt)
	{
		case "down":
		
			currentButton = div;
			buttonDown = true;
			getEI(div).src = "images/" + div + "_pressed.png";
			break;
			
		case "up":
		
			buttonDown = false;
			getEI(currentButton).src = "images/" + currentButton + ".png";
			var display;
			switch (selectedText)
			{
				case "alarm_hour":
					display = (alarmSet & 0x1f00) >>>8;
					switch (currentButton)
					{
						case "up":
							display += 1;
							display %= 24;
							break;
						
						case "down":
							display -=1;
							if (display < 0)
								display = 23;
							break;
					}
					alarmSet &= 0x20ff;
					alarmSet |= (display << 8);					
					break;
					
				case "alarm_minute":
					display = (alarmSet & 0xff);
					switch (currentButton)
					{
						case "up":
							display += 1;
							display %= 60;
							break;
						
						case "down":
							display -=1;
							if (display < 0)
								display = 59;
							break;
					}
					alarmSet &= 0x3f00;
					alarmSet |= display;
					break;					
			}
			getEI(selectedText).innerHTML = formatNumber(display.toString());
			saveKey(alarmSet, "alarmSet");
			currentButton = "";
			break;
			
		case "over":
		
			if (buttonDown && currentButton == div)
				getEI(div).src = "images/" + div + "_pressed.png";
			break;
			
		case "out":
		
			if (buttonDown && currentButton == div)
				getEI(div).src = "images/" + div + ".png";
			break;
	}

	event.stopPropagation();
	event.preventDefault();
}


//=================================闹钟设置
function ringset(event)
{
	if(alarmSet & 0x2000){
		event.target.src = "Images/ring.png";
		alarmSet &= 0x1fff;
	}
	else{
		event.target.src = "Images/ring_pressed.png";
		alarmSet |= 0x2000;
	}
	saveKey(alarmSet, "alarmSet");
	event.stopPropagation();
	event.preventDefault();
}

//=================================闹铃 30秒，每秒一次
function alarmRing(duration, alarm)
{
	var alarmsound;
	var aringing;
	if (alarm){
		aringing = (alarmSet & 0x2000);
		alarmsound = getEI("alarmwav");
	}
	else {
		aringing = true;
		alarmsound = getEI("timewav");
	}
	
	if (second < duration && aringing)
	{
			alarmsound.Play();
	}
	else
		stopAlarm(alarm);
}

//=================================停止闹钟
function stopAlarm(alarm)
{
	if (ringTimer != null)
	{
		clearInterval(ringTimer);
		ringTimer = null;
	}
	
	if (alarm)
		getEI("alarmwav").Stop();
	else
		getEI("timewav").Stop();
}


//=======================================快捷键设置
document.addEventListener("keypress", keyPressed, true);

function keyPressed(e)
{
	if (!(viewStatues & 0xf0))
	{
		if (viewStatues & 0x04)
		{
			if (!currentDate)
				currentDate = 1;
			
			var mo = new Date(currentYear, currentMonth, currentDate);
			var dateChanged = false;
			var monthYearView = false;
		
			switch (e.keyIdentifier) {
			//上下左右键调整日期，加苹果键调整年（上下）月（左右）
				case "Up":
					if (e.metaKey) {
						mo.setFullYear(currentYear+1);
						monthYearView = true;
					}
					else
						mo.setDate(currentDate-7);
					dateChanged = true;
					break;
				case "Down":
					if (e.metaKey) {
						mo.setFullYear(currentYear-1);
						monthYearView = true;
					}
					else
						mo.setDate(currentDate+7);
					dateChanged = true;
					break;
				case "Right":
					if (e.metaKey) {
						currentMonth++;
						if (currentMonth > 11) {
							currentMonth = 0;
							currentYear++;
						}
						mo.setMonth(currentMonth);
						mo.setFullYear(currentYear);
						monthYearView = true;
					}
					else
						mo.setDate(currentDate+1);
					dateChanged = true;
					break;
				case "Left":
					if (e.metaKey) {
						currentMonth--;
						if (currentMonth < 0) {
							currentMonth = 11;
							currentYear--;
						}
						mo.setMonth(currentMonth);
						mo.setFullYear(currentYear);
						monthYearView = true;
					}
					else
						mo.setDate(currentDate-1);
					dateChanged = true;
					break;
			
			//翻页键调整月份
				case "PageUp":
					currentMonth--;
						if (currentMonth < 0) {
						currentMonth = 11;
						currentYear--;
						}
					mo.setMonth(currentMonth);
					mo.setFullYear(currentYear);
					monthYearView = true;
					dateChanged = true;
					break;
			
				case "PageDown":
					currentMonth++;
					if (currentMonth > 11) {
						currentMonth = 0;
						currentYear++;
					}
					mo.setMonth(currentMonth);
					mo.setFullYear(currentYear);
					monthYearView = true;
					dateChanged = true;
					break;
		
			//Home键返回当前日
				case "Home":
					currentMonth = date.getMonth();
					mo.setMonth(currentMonth);
					currentYear = date.getFullYear();
					mo.setFullYear(currentYear);
					currentDate = date.getDate();
					mo.setDate(currentDate);
					dateChanged = true;
					break;
				
				default:
				
					break;
			}
		
		//改变当前的年月日
			if (dateChanged)
			{
				// 创建新的日历
				currentMonth = mo.getMonth();
				currentYear = mo.getFullYear();
				currentDate = mo.getDate();
				setupMonth(currentMonth, currentYear);
				
				hiliteToday();
				
				if (!monthYearView)
					hiliteDate(idFromMonthDate(currentMonth, currentDate));
				else
					hiliteDate("");
			
				if (monthYearView)
					currentDate = 0; // note this makes the id of the form mm00yyyy which doesn't correspond to an HTML id

				updateTiles();
				
				selectedDateID = idFromMonthDate (currentMonth, currentDate);
			
				e.stopPropagation();
				e.preventDefault();
			}
		}
		
		if (viewStatues & 0x01)
		{
			if (e.charCode <= 57 && e.charCode >= 48)
			{
				var preText = parseInt(getEI(selectedText).innerText);
				var inputText = e.charCode - 48;
				if (selectedText == "alarm_hour") {
					if (preText < 3)
					{
						if (preText == 2 && inputText > 3)
							preText = inputText;
						else
							preText = preText*10 + inputText;
					}
					else
						preText =  inputText;
					alarmSet &= 0x20ff;
					alarmSet |= (preText << 8);
					getEI(selectedText).innerText = formatNumber(preText.toString());
				}
				else if (selectedText == "alarm_minute") {
					if (preText < 6)
					{
						preText = preText*10 + inputText;
					}
					else
						preText =  inputText;
					alarmSet &= 0x3f00;
					alarmSet |= preText;
					getEI(selectedText).innerText = formatNumber(preText.toString());			
				}
				saveKey(alarmSet, "alarmSet");
			}
		}
	}
}

function mouseUp (inEvent, inTag)
{
	if(inTag !="dragon" && inTag != "sm"){
		inEvent.target.src = "Images/"+inTag+".png";
		
		if (inTag == "bar_left")
		{
			changeMonth(inEvent, false);
		}
		else if (inTag == "bar_right")
		{
			changeMonth(inEvent, true);
		}
		else	// inTag == bar_middle
		{
			jumpToToday (inEvent);
		}
	}
	else if (inTag == "sm"){
		flipper.doneNotification = thfade;
		flipper.fadetime = 5000;
		if (flipper.fadingIn){
			flipper.fadeOut();
		}
		else{
			smflipper.doneNotification = ffadeIn;
			smflipper.fadeOut();
		}
	}
	else{
		if (transSet == 1)
			transSet = -1;
		if (transSet < -0.3)
		{ 
			transSet += 0.2;
		}
		else
		{
			transSet = Math.abs(transSet)+0.2;
		}
		face.style.opacity = Math.abs(transSet);
		flipper.now = Math.abs(transSet);
		saveKey(transSet,"transSet");
	};
	
	inEvent.stopPropagation();
	inEvent.preventDefault();
}

function mouseOut (event, tag)
{
	if(tag !="dragon" && tag !="sm"){
		event.target.src = "Images/"+tag+".png";}
}

function mouseDown(event, tag)
{
	if(tag !="dragon" && tag !="sm"){
		event.target.src = "Images/"+tag+"_pressed.png";
	}
	event.stopPropagation();
	event.preventDefault();
}

//========================================最小化===================================
function thfade()
{
	if (!flipper.fadingIn){
		clearHands();
		viewStatues |= 0x10;
		sm1.style.visibility = "visible";
		smflipper.fadeIn();
	}
	else {
		sm1.style.visibility = "hidden";
		setTimeout('updateDate();',0);
		viewStatues &= 0xef;
		updateclock = true;
	}
	saveKey(viewStatues, "viewStatues");
}

function ffadeIn()
{
	flipper.fadeIn();
}

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}



function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}


//====================================翻转============================================
function enterflip(event)
{
	getEI('fliprollie').style.display = 'block';
}


function exitflip(event)
{
	getEI('fliprollie').style.display = 'none';
}


function mousemove (event)
{
	if (!flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = getEI ('flip');
		animation.timer = setInterval ("f_animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		f_animate();
		flipShown = true;
	}
}


function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = getEI ('flip');
		animation.timer = setInterval ("f_animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		f_animate();
		flipShown = false;
	}
}


function f_animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.element.style.opacity = animation.now;
}

function showbackside(event)
{
	var front = getEI("all");
	var back = getEI("behind");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	
	front.style.display="none";
	back.style.display="block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	

	getEI('fliprollie').style.display = 'none';
	
	if (!(viewStatues & 0xf0) && (viewStatues & 0x01))
		clearHands();

	viewStatues |= 0x20;
	saveKey(viewStatues, "viewStatues");
}

function doneClicked() {
	var front = getEI("all");
	var back = getEI("behind");

    if (window.widget)
    	widget.prepareForTransition("ToFront");


    front.style.display="block";
    back.style.display="none";

    setTimeout ('flipitback();', 0);
}

function flipitback()
{
	if (window.widget)
		setTimeout("widget.performTransition();", 0);
	
	viewStatues &= 0xdf;
	setTimeout('updateDate();',0);
	initialClock(false);
	updateclock = true;
	saveKey(viewStatues, "viewStatues");
}

//==============================================程序设置=============================
function jingOWChanged(select)
{
	if (select.selectedIndex)
		cityJing = -Math.abs(cityJing);
	else
		cityJing = Math.abs(cityJing);

	saveKey (cityJing, "cityJing");
}


function weiNSChanged(select)
{
	if (select.selectedIndex)
		cityWei = -Math.abs(cityWei);
	else
		cityWei = Math.abs(cityWei);

	saveKey (cityWei, "cityWei");
}

function timeRINGChanged(select)
{
	if (select.selectedIndex)
		wholeRing = -Math.abs(wholeRing);
	else
		wholeRing = Math.abs(wholeRing);

	saveKey (wholeRing, "wholeRing");
}


function changeJD()
{
	if (window.widget)
	{
		var jing = parseInt (getEI("jingG").value);
		if (isNaN(jing) || jing <0 || jing >180)
		{
			jing = Math.abs(ipart(default_cityJing));
		}
		getEI("jingG").value = jing;
		if (cityJing<0)
			cityJing = - jing - frac(cityJing);
		else
			cityJing = jing + frac(cityJing);
		saveKey(cityJing, "cityJing");
	}
}


function changeJF()
{
	if (window.widget)
	{
		var jings = parseInt (getEI("jingF").value);
		if (isNaN(jings) || jings <0 || jings >59)
		{
			jings = Math.round(frac(default_cityJing)*60);
		}
		getEI("jingF").value = jings;
		if (cityJing<0)
			cityJing = ipart(cityJing) - jings/60;
		else
			cityJing = ipart(cityJing) + jings/60;
		saveKey(cityJing, "cityJing");
	}
}

function changeWD()
{
	if (window.widget)
	{
		var wei = parseInt (getEI("weiG").value);
		if (isNaN(wei) || wei <0 || wei >90)
		{
			wei = Math.abs(ipart(default_cityWei));
		}
		getEI("weiG").value = wei;
		if (cityWei<0)
			cityWei = - wei - frac(cityWei);
		else
			cityWei = wei + frac(cityWei);
		saveKey(cityWei, "cityWei");
	}
}


function changeWF()
{
	if (window.widget)
	{
		var weis = parseInt (getEI("weiF").value);
		if (isNaN(weis) || weis <0 || weis >59)
		{
			weis = Math.round(frac(default_cityWei)*60);
		}
		getEI("weiF").value = weis;
		if (cityWei<0)
			cityWei = ipart(cityWei) - weis/60;
		else
			cityWei = ipart(cityWei) + weis/60;
		saveKey(cityWei, "cityWei");
	}
}

function changeAD()
{
	if (window.widget)
	{
		var ring_duration = parseInt (getEI("alarmDUR").value);
		if (isNaN(ring_duration) || ring_duration < 0)
			ring_duration = default_wholeRing;
		getEI("alarmDUR").value = ring_duration;
		if (wholeRing < 0)
			wholeRing = -ring_duration;
		else
			wholeRing = ring_duration;
		saveKey(wholeRing, "wholeRing");
	}
}

function pressBall(event, id)
{
	if (viewStatues & id)
	{
		viewStatues &= (0xff - id);
		if (!(id & 8))
		{
			Sizes[3] -= Sizes[id];
			event.target.src = "Images/ball_d.png";
		}
	}
	else
	{
		viewStatues |= id;
		if (!(id & 8))
		{
			Sizes[3] += Sizes[id];
			event.target.src = "Images/ball.png";
			if (id & 2)
				updateclock =true;
			if(id & 1)
				initialClock(true);
		}		
	}
	setTimeout('updateDate();',0);
	toggleResizing (event.shiftKey, id);
	saveKey(viewStatues,"viewStatues");
}

function toggleResizing (doItSlow, id)
{
	if(id & 8)
	{
		var midDiv = getEI("calMid");
		var resizeTo = (viewStatues & id) ? Sizes[3] : 77;
		var startingSize = (viewStatues & id) ? 77 : Sizes[3];
	}	
	else
	{
		var midDiv = getEI("mid"+id);
		var resizeTo = (viewStatues & id) ? Sizes[id] : 0;
		var startingSize = (viewStatues & id) ? 0 : Sizes[id];
	}
	var timeNow = (new Date).getTime();
	var multiplier = (doItSlow ? 10 : 1);
	resizeAnimation.element = midDiv;
	
	if (resizeAnimation.timer != null) // it is moving... change to new size
	{
		clearInterval(resizeAnimation.timer);
		resizeAnimation.timer = null;
		resizeAnimation.duration -= (timeNow - resizeAnimation.startTime);
		resizeAnimation.positionFrom = resizeAnimation.positionNow;
	}
	else
	{
		resizeAnimation.duration = 500 * multiplier;
		resizeAnimation.positionFrom = startingSize;
	}
	resizeAnimation.elementId = id;
	resizeAnimation.positionTo = parseInt(resizeTo, 10);
	resizeAnimation.startTime = timeNow - 13;
	resizeAnimation.onfinished = resized;
	resizeAnimation.element.style.height = startingSize;
	resizeAnimation.timer = setInterval ("animate();", 13);
	animate();
}

function animate ()
{
	var T;
	var ease;
	var time  = (new Date).getTime();
	var yLoc;
	var frame;

	
	T = limit_3(time-resizeAnimation.startTime, 0, resizeAnimation.duration);
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / resizeAnimation.duration));

	if (T >= resizeAnimation.duration)
	{
		yLoc = resizeAnimation.positionTo;
		clearInterval (resizeAnimation.timer);
		resizeAnimation.timer = null;
		
		if (resizeAnimation.onfinished)
			setTimeout ("resizeAnimation.onfinished(resizeAnimation.elementId);", 0); // call after the last frame is drawn
	}
	else
		yLoc = computeNextFloat(resizeAnimation.positionFrom, resizeAnimation.positionTo, ease);

	resizeAnimation.positionNow = Math.round(yLoc);
	resizeAnimation.element.style.height = resizeAnimation.positionNow;
	
	if (!(resizeAnimation.elementId & 8))
	{
		if (viewStatues & resizeAnimation.elementId)
			getEI("calMid").style.height = Sizes[3] - Sizes[resizeAnimation.elementId] + resizeAnimation.positionNow;
		else
			getEI("calMid").style.height = Sizes[3] + resizeAnimation.positionNow;
	}
}

function resized (id)
{
	if (viewStatues & id)
	{
		if (id & 8)
		{
			getEI("ball_left").style.visibility = "visible";
			getEI("ball_mid").style.visibility = "visible";
			getEI("ball_right").style.visibility = "visible";
		}
	}
	else
	{
		if (id & 8)
		{
			getEI("ball_left").style.visibility = "hidden";
			getEI("ball_mid").style.visibility = "hidden";
			getEI("ball_right").style.visibility = "hidden";
		}
	}
}

