function load()
{
    name = 'abracadabra';
    version = '1.1';
    paths = new Array();
    usePassword = false;
    passwordHash = "de2b14ae7499f90736fc4a92327553a5";
    defaultHash = "de2b14ae7499f90736fc4a92327553a5";
    pw = "de2b14ae7499f90736fc4a92327553a5";
    pwTemp = null;
    locked = false;
    timer = null;
    frame = 1;
    poof = null;
    pwHasFocus = true;
    logging = false;
    updateReq = null;
    visible = true;
    animID = null;
    
    DBexists = widget.system("ls -a ~/Library/Widgets | grep abracadabra.db", null).outputString;
    if(!DBexists)
       widget.system('echo de2b14ae7499f90736fc4a92327553a5 > ~/Library/Widgets/.abracadabra.db',null);
    
    createGenericButton(document.getElementById('doneButton'), "Done", showfrontside, 50);
    createGenericButton(document.getElementById('donateButton'), "Donate", donate, 60);
    
    pathlist = widget.system("cat ~/Library/Widgets/.abracadabra.db", null).outputString;
    if(pathlist)
    {
        paths = pathlist.split('\n');
        passwordHash = paths.shift();
    }
    
    if(passwordHash == defaultHash) unlock();
    else lock();
    
    window.onkeydown = keyDown;
}

if (window.widget)
{
   widget.onshow = onshow;
   widget.onhide = onhide;
}

function onshow () {
    visible = true;
    animID = setInterval(advanceFrame, 60);
}

function onhide () {
    visible = false;
    clearInterval(animID);
}

function dragdrop (event)
{
    var uri = null;
    
    document.getElementById('sparkle').src = 'images/nothing.png';
    
    if(locked) {
    	showError("Locked", 2000);
    
    } else {
        try { uri = event.dataTransfer.getData("text/uri-list"); }
        catch (ex) { logAlert("Error: " + ex); }
        
        if (uri) {
            uri = uri.toString();
            uri = uri.replace(/[^a-z0-9.:\/\S!@#$%^&*()_-+=;\'\",?|]/gi,"\n");
            uri = uri.replace(/file:\/\/localhost/gi,'');
            uri = uri.replace(/%20/gi,' ');
            uri = uri.split("\n");
            
            
            for(j = 0; j < uri.length; j++) {
               makeDisappear(uri[j]);
            }
        }
    }
    event.stopPropagation();
    event.preventDefault();
    clearInterval(animID);
    animID = null;
}

function dragenter (event)
{
    event.stopPropagation();
    event.preventDefault();
}

function dragover (event)
{
    if(!locked)
        document.getElementById('sparkle').src = "images/sparkle_" + frame + ".png";
    
    if(poof){
        clearTimeout(poof);
        poof = null;
    }
    
    event.stopPropagation();
    event.preventDefault();
}

function dragleave (event)
{
    sparkling = false;
    poof = setTimeout("document.getElementById('sparkle').src = 'images/nothing.png';", 200);
    event.stopPropagation();
    event.preventDefault();
}

function loadPaths()
{
	logAlert("Decrypting paths...");
	
    pathlist = widget.system("cat ~/Library/Widgets/.abracadabra.db", null).outputString;
    
    if(pathlist)
    {
        paths = pathlist.split('\n');
        passwordHash = paths.shift();
        
        for(i = 0; i < paths.length - 1; i++)
        {
            decryptedPath = widget.system('~/Library/Widgets/Abracadabra.wdgt/decrypt.pl \'' + paths[i] + '\' ' + pw, null).outputString;
            logAlert(paths[i] + " : " + decryptedPath);
            
            if(decryptedPath)
            {
                decryptedPath = decryptedPath.replace(/\n/g, "");
                paths[i] = decryptedPath;//paths[i] = Wand.wave(paths[i], false);
            } else {
                showError("Errors encountered in decryption", 2000);
                logAlert("Decryption Error (" + paths[i] + ")");
            }
        }
        populateFilePopup();
    }
    
    if(paths.length == 0)
    {
        HTML = "<select id='files' style='width:190'>";
        HTML += "<option value='default'>The hat is empty</option></select>";
        document.getElementById('filePopup').innerHTML = HTML;
    }
    return true;
}

function savePaths()
{
	logAlert("Encrypting paths...");
    widget.system('echo ' + passwordHash + '> ~/Library/Widgets/.abracadabra.db',null);
    
    for(i = 0; i < paths.length; i++)
    {
       encryptedPath = widget.system('~/Library/Widgets/Abracadabra.wdgt/encrypt.pl \'' + paths[i] + '\' ' + pw, null).outputString;
       encryptedPath = encryptedPath.replace(/\n/g, "");
       logAlert(paths[i] + " : " + encryptedPath);
       widget.system('echo ' + encryptedPath + ' >> ~/Library/Widgets/.abracadabra.db', null);
    }
}

function fileFromPath(path,dir)
{
    file = path.split("/");
    if(file[file.length-1] != "")
        return file[file.length-1];
    else
        return file[file.length-2] + ((dir) ? " (directory)" : "");
}

function trimFilename(filename)
{
    if(filename.length > 18)
        filename = filename.substring(0,18) + "...";
    return filename;
}

function makeDisappear(file)
{
        if(mv(file, true))
        {
            addToFilePopup(file);
            savePaths();
        } else
            showError(trimFilename(fileFromPath(file,false)) + " cannot be hidden", 2000);
}

function makeAppear() {
    file = document.getElementById('files').value;

    if(file == "default")
        showError("Please select a<br>file first", 2000);
    else {
        if(!mv(file, false))
            showError("File not found", 2000);
        removeFromFilePopup();
    }
    savePaths();
}

function mv(file, flag)
{
    dotfile = file.split('/');
    
    if(dotfile[dotfile.length-1] == '')
        dotfile[dotfile.length-2] = '.' + dotfile[dotfile.length-2];
    else
        dotfile[dotfile.length-1] = '.' + dotfile[dotfile.length-1];
    
    dotfile = dotfile.toString();
    dotfile = dotfile.replace(/,/g,"/");
    
    if(flag) command = "/bin/mv '" + file + "' '" + dotfile + "'";
    else command = "/bin/mv '" + dotfile + "' '" + file + "'";
    
    error = widget.system(command,null).errorString;
    
    if(error) {
       logAlert("Error: " + error);
       return false;
    } else return true;
}

function addToFilePopup(path)
{
    paths.push(path);
    populateFilePopup();
}

function removeFromFilePopup()
{
    index = document.getElementById('files').selectedIndex;
    paths.splice(index-1,1);
    populateFilePopup();
}

function populateFilePopup()
{
    HTML = "<select id='files' style='width:190' onChange='makeAppear();'>";
    HTML += "<option value='default'>Select a file to pull from hat</option>";

    for(i = 0; i < paths.length; i++) {
        if(paths[i] != "")
        {
            file = fileFromPath(paths[i],true);
            HTML += "<option value='" + paths[i] + "'>" + file + "</option>";
        } else {
            paths.splice(i,1);
            i--;
        }
    }
    if(i == 0) {
        HTML = "<select id='files' style='width:190'>";
        HTML += "<option value='default'>The hat is empty</option></select>";
    } else
        HTML += "</select>";
    
    document.getElementById('filePopup').innerHTML = HTML;
}

function toggleLock()
{
    pw = document.getElementById('password').value;
    
    if(locked) {
        enteredHash = widget.system('echo ' + pw + ' | md5', null).outputString;
        enteredHash = enteredHash.substring(0,enteredHash.length-1);
        
        if(enteredHash == passwordHash)
        	unlock();
        else { 
        	showError('Incorrect passord', 2000);
        	focusPasswordField();
        }
    } else {
        if(pw == "")
            if(passwordHash == defaultHash)
            {
                showError("Please provide a<br>password", 2000);
                focusPasswordField();
            } else {
                showError("Password cleared", 2000);
                passwordHash = defaultHash;
                pw = defaultHash;
                savePaths();
            }
        else {
            if(pwTemp == null)
            {
            	pwTemp = pw;
            	showAlert('Please confirm<br>password.', 2000);
            	document.getElementById('password').value = '';
            } else if(pw == pwTemp)
            {
            	passwordHash = widget.system('echo ' + pw + ' | md5', null).outputString;
            	passwordHash = passwordHash.substring(0,passwordHash.length-1);
            
            	savePaths();
            	showAlert('Locked', 2000);
            	lock();
            	pwTemp = null;
            } else {
            	showAlert("Confirmation invalid,<br>please try again.", 2000);
            	document.getElementById('password').value = '';
            	pwTemp = null;
            }
        }
    }
}

function lock()
{
    locked = true;

	document.getElementById('front').style.background = "url('images/frontside_locked.png')";
	document.getElementById('backimg').src = 'images/backside_locked.png';
	alert(document.getElementById('front').style.background);
    document.getElementById('lock').src = 'images/locked.png';
    document.getElementById('password').value = '';
    document.getElementById('files').disabled = true;
    focusPasswordField();

    showAlert('Locked', 2000);
 }

function unlock()
{
    if(loadPaths())
    {
    
    	locked = false;
    
    	document.getElementById('front').style.background = "url('images/frontside.png')";
		document.getElementById('backimg').src = 'images/backside.png';
    	document.getElementById('lock').src = 'images/unlocked.png';
    	document.getElementById('files').disabled = false;
    	focusPasswordField();

    	showAlert('Unlocked', 2000);    
	} else {
		showError('Corrupt Password', 2000);
	}
}

function focusPasswordField()
{
    document.getElementById('password').focus();
    document.getElementById('password').select();
}

function showAlert(e, secs)
{
    document.getElementById('fronterror').innerHTML = e;
    document.getElementById('backerror').innerHTML = e;
    if(timer) clearInterval(timer);
    timer = setTimeout(clearError, secs);
}

function showError(e, secs)
{
    BeepPlugin.beep();
    showAlert(e, secs);
}

function clearError()
{
    document.getElementById('fronterror').innerHTML = "&nbsp;";
    document.getElementById('backerror').innerHTML = "&nbsp;";
}

function logAlert(message)
{
	if(logging) alert(message);
}

function toggleLogging()
{
	logging = !logging;
	alert("Logging " + ((logging) ? "on." : "off."));
}

function showbackside()
{
    if (window.widget) {
        widget.prepareForTransition("ToBack")
    }
    
    document.getElementById("front").style.display="none";
    document.getElementById("back").style.display="block";
    document.getElementById('fliprollie').style.display = 'none';
    document.getElementById('password').blur();
    document.getElementById('password').focus();
    document.getElementById('password').select();
    
    checkForUpdate();
    
    if (window.widget) {
        setTimeout ('widget.performTransition();', 0)
    }
}

function showfrontside() {
    
    if (window.widget) {
       widget.prepareForTransition("ToFront")
    }
    
    document.getElementById("front").style.display="block";
    document.getElementById("back").style.display="none";
    setTimeout ('widget.performTransition();', 0);
}

function advanceFrame()
{
    frame += 1;
    if(frame > 24) frame = 1;
}

function handleUpdateResponse()
{
	if(updateReq.readyState == 4 && updateReq.status == 200)
    {
    	latestVersion = updateReq.responseText;
		if(latestVersion)
		{
			if (version < latestVersion) {
				text = "<a href=\"javascript:widget.openURL('http://www.interdimensionmedia.com/downloads/abracadabra.zip');\"> Version " + latestVersion + " available.<br>Click to download.</a>";
				showAlert(text, 8000);
			}
		}
	}
}

function checkForUpdate()
{
    updateReq = new XMLHttpRequest();
    url = "http://www.interdimensionmedia.com/widgets/widgetversion.php?widget=" + name;
	updateReq.open("GET", url, true);
	updateReq.onreadystatechange = handleUpdateResponse;
	updateReq.send(null);
}

function keyDown(e)
{
    if(window.widget && document.getElementById('front').style.display == 'none')
    {
        key = true;
        alert(e.keyCode);
        
        switch(e.keyCode) {
        	case 13: if(pwHasFocus) toggleLock();
        	break;
        	case 192: toggleLogging();
        }
    }
}

// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)
var flipShown = false;


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the
// front div of the widget. It is triggered whenever a mouse is moved within the
// bounds of your widget.  It prepares the preference flipper fade and then 
// calls animate() to performs the animation.

function mousemove (event)
{
    if (!flipShown)     // if the preferences flipper is not already showing...
    {
        //reset the timer
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        
        var starttime = (new Date).getTime() - 13;  // set it back one frame
        
        animation.duration = 500;                                               // animation time, in ms
        animation.starttime = starttime;                                        // specify the start time
        animation.firstElement = document.getElementById ('flip');              // specify the element to fade
        animation.timer = setInterval ("animate();", 13);                       // set the animation function
        animation.from = animation.now;                                         // beginning opacity (not ness. 0)
        animation.to = 1.0;                                                     // final opacity
        animate();                                                              // begin animation
        flipShown = true;                                                       // mark the flipper as animated
    }
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences 
// flipper to disappear.  It adds the appropriate values to the animation data
// structure and sets the animation in motion.

function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the flip widget
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        
        var starttime = (new Date).getTime() - 13;
        
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

// animate() performs the fade animation for the preferences flipper.
// It uses the opacity CSS property to simulate a fade.
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
    
    T = limit_3(time-animation.starttime, 0, animation.duration);
    
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
    
    animation.firstElement.style.opacity = animation.now;
}

// these functions are utilities used by animate()
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}

function donate() {
    widget.openURL('https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=eben@interdimensionmedia.com&item_name=Abracadabra');
}