//+------------------------------------------- 
//| BatteryInfo Widget
//+------------------------------------------- 
//| $LastChangedDate$
//+-------------------------------------------
//| Info:
//| Copyright (c) 2005 Ben Barnett
//| widgets@menial.co.uk
//+-------------------------------------------


/***
* Get localized string
*
* Will return a string in the users language if available,
* or will use the element ID instead
***/
function getLocalizedString (key)
{
    try {
        var ret = localizedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    } catch (ex) {}
    return key;
}

/***
* Loads strings for display
*
* Called from onShow, this loads the correct
* language strings.
***/
function loadLocalizedStrings()
	{	
	if (debug) alert('DEBUG: Loading localized strings');
	document.getElementById('updateevery').innerText = getLocalizedString('updateevery');
	document.getElementById('seconds').innerText = getLocalizedString('seconds');
	document.getElementById('showpercentage').innerText = getLocalizedString('showpercentage');
	document.getElementById('showtime').innerText = getLocalizedString('showtime');
	document.getElementById('version').innerText = 'v'+widgetVersion;
	}