/*
Copyright &copy; 2005, Xnet Communications GmbH.  All rights reserved.
*/

var cmdStatus = null;
var timer = null;
var timerInterval = 120000; // updates every two minutes
var animTransTimerNavigate;
var animTransTimerInform;
var animTransTimerAnchor;
var animTransTimerSail;
var cftpInstalled = false;

/*################# preferences & localized strings ##################*/

function getLocalizedString (key)
{
	try {
		var ret = localizedStrings[key];
		if (ret === undefined)
			ret = key;
		return ret;
	} catch (ex) {}

	return key;
}

function createKey(key) {
	return widget.identifier + "-" + key;
}

function loadConnectionData(select,nr) {
var command='';
var output='';
	//alert(nr);
	if (nr>0) {
		command="GetAB server "+select.text;
		output = widget.system(command, null).outputString;
		//alert('#'+command+'#'+output);
	} else {
		for (i=0;i<6;i++) output+=String.fromCharCode(10); 
	}
	//alert(output);
	var pop=0;
	var index=0;
	var i=0;
	var character=String.fromCharCode(10);
	while (index<output.length) {
		pop=index;
		index=output.indexOf(character,index);
		if (index>-1) {
			switch (i) {
				case 0:
					document.getElementById('serverinput').value=output.substring(pop,index);
					document.getElementById('serverinput1').value=output.substring(pop,index);				
					break;
				case 1: document.getElementById('userinput').value=output.substring(pop,index); break;
				case 2: document.getElementById('passinput').value=output.substring(pop,index); break;
				case 3: document.getElementById('pathinput').value=output.substring(pop,index); break;
				case 4: if (output.substring(pop,index)=='Y') document.getElementById('passiveinput').checked = true; else document.getElementById('passiveinput').checked = false; break;
				case 5: if (typeof (document.getElementById('protocolinput').options.namedItem(output.substring(pop,index))) != 'undefined') document.getElementById('protocolinput').options.namedItem(output.substring(pop,index)).selected = true; else document.getElementById('protocolinput').options.namedItem('FTP').selected = true;  
					break;
				default: break;
			}
			i++;
			index++;
		} else index=output.length;
	}
	prefRetype(document.getElementById('serverinput'), 'server');
	prefRetype(document.getElementById('userinput'), 'user');
	prefRetype(document.getElementById('passinput'), 'pass');
	prefRetype(document.getElementById('pathinput'), 'path');
	prefRetype(document.getElementById('passiveinput'), 'passive');
	prefRetype(document.getElementById('protocolinput').options[document.getElementById('protocolinput').selectedIndex], 'protocol');
	
	prefChanged(document.getElementById('serverinput'), 'server');
	prefChanged(document.getElementById('userinput'), 'user');
	prefChanged(document.getElementById('passinput'), 'pass');
	prefChanged(document.getElementById('pathinput'), 'path');
	prefChanged(document.getElementById('passiveinput'), 'passive');
	prefChanged(document.getElementById('protocolinput').options[document.getElementById('protocolinput').selectedIndex], 'protocol');
}

function prefRetype(select, key) {
var elem=key+'inputlabel';
var pass='';
	switch (key) {
		case 'passive':
			if (select.checked)	document.getElementById('passive-img').src='Images/captain_cbox_x.png'; else document.getElementById('passive-img').src='Images/captain_cbox_o.png';
			break;
		case 'pass':
			for (i=0;i<select.value.length;i++) pass+='&middot;';
			document.getElementById(elem).innerHTML=pass;
			break;
		default:
			document.getElementById(elem).innerText=select.value;
			break;
	}
}

function focusControl(select, key) {
var elem=key+'inputlabel';
	if (!isCollapsed) {
		document.getElementById(elem).style.opacity=0;
		select.style.opacity=1;
	}
}

function blurControl(select, key) {
var elem=key+'inputlabel';
	prefRetype(select, key);
	select.style.opacity=0;
	document.getElementById(elem).style.opacity=1;
}

function prefChanged(select, key) {
	if (window.widget) {
		switch (key) {
			case 'passive':
				//alert("Setting key "+createKey(key)+" to value "+(select.checked ? "Y" : "N"));
				widget.setPreferenceForKey((select.checked ? "Y" : "N"), createKey(key));
				break;
			default:
				//alert("Setting key "+createKey(key)+" to value "+select.value);
				widget.setPreferenceForKey(select.value, createKey(key));
				break;
		}
	}
	updateFront(false,"","");
}

/*################# rotating widget ##################*/

var totalWidgetHeight = 0;
var totalWidgetWidth = 0;
var topOffset = 0;
var leftOffset = 0;
var maxImageWidth = 0;
var maxImageHeight = 0;
var isShowingFront = true;

function calculateBackgroundHeight ()
{
	var height;
	if (isCollapsed)
		height = 324;
	else
		height = 444;
		
	height +=  topOffset;
	if (height < maxImageHeight) 
		height = maxImageHeight; // make sure there is enough room for icon;

	return height;
}

function calculateBackgroundWidth ()
{
	var w = 280 + leftOffset;
	
	return w > maxImageWidth ? w : maxImageWidth;
}
		
function ShowBack (event)
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	isShowingFront = false;
	
	if (window.widget)
	{
		// reisze the widget to the large size
		var backSize = 444 + topOffset;
		if (totalWidgetHeight < backSize)
		{
			window.resizeTo (calculateBackgroundWidth(), backSize);
			resizedWhenShowedBack = true;
		}
		else
			resizedWhenShowedBack = false;
		widget.prepareForTransition("ToBack");
	}
	
	front.style.display="none";
	back.style.display="block";
	
	document.getElementById('fliprollie').style.display = 'none';
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
	
	// do not receive updates when showing the backside
	if (timer != null)
	{
		clearInterval(timer);
		timer = null;
	}
		
	event.stopPropagation();
	event.preventDefault();
}

function ShowFront ()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	isShowingFront = true;
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	front.style.display="block";
	back.style.display="none";
	
	document.getElementById('fliprollieback').style.display = 'none';
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}

/*################# resizing widget ##################*/

var resizeAnimation = {startTime:0, duration:250, positionFrom:0, positionTo:0, positionNow:0, frameFrom:0, frameTo:0, frameNow:0, timer:null, element:null, image:null, background:null, onfinished:null};
var isCollapsed = true;
var isMoved = false;

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}

function animate (elem) {
	var T;
	var ease;
	var time  = (new Date).getTime();
	var yLoc;
	var frame;
		
	T = limit_3(time-resizeAnimation.startTime, 0, resizeAnimation.duration);
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / resizeAnimation.duration));

	if (T >= resizeAnimation.duration)
	{
		yLoc = resizeAnimation.positionTo;
		clearInterval (resizeAnimation.timer);
		resizeAnimation.timer = null;
		
		if (resizeAnimation.onfinished) setTimeout ("resizeAnimation.onfinished();", 0); // call after the last frame is drawn
	}
	else yLoc = computeNextFloat(resizeAnimation.positionFrom, resizeAnimation.positionTo, ease);
		
	// convert to a integer, not sure if this is the best way
	resizeAnimation.positionNow = parseInt(yLoc);
	resizeAnimation.element.style.height = resizeAnimation.positionNow + "px";
	
	//alert(elem);
	
	switch (elem) {
		case 'anchor':
			// anchor up/down
			document.getElementById('anchor-contents').style.top = -51 -20 + resizeAnimation.positionNow + "px";
			break;
		case 'middle':
			// move the layer (end of board + anchor) left/right
			/*max_move_x=9;
			for (x=1;x<=max_move_x;x++) {
				if (T >= ((x/max_move_x) * resizeAnimation.duration)) {
					document.getElementById('bottom-contents').style.left = (isCollapsed ? max_move_x - x : x) + "px";
				}
			}*/
			break;
	}
}

function randomValue(low, high) {
   return Math.floor(Math.random() * (1 + high - low) + low);
}

function animFinished(elem) {
	
	if (window.widget)
	{
	 	switch (elem) {
			case 'middle':
				if (isCollapsed) {
					totalWidgetHeight = calculateBackgroundHeight();
					window.resizeTo (calculateBackgroundWidth(), totalWidgetHeight);
					document.getElementById('done').style.visibility = "hidden";
					document.getElementById('serverinputlabel1line').style.visibility = "visible";
					document.getElementById('serverinputlabel2line').style.visibility = "visible";
					updateFront(true,"","");
				} else {
					document.getElementById('done').style.visibility = "visible";
					updateFront(false,"","");
				}				
				break;
			case 'anchor':
				break;
		}
	}
}

function onclick1() {
	void('null');
}

function onclick2() {
	MouseClicked(event,"middle",0,120);
}

function animTransmition(comm,status) {
var delay=0;
	document.getElementById('top').onclick=onclick1;
	document.getElementById('bottom-contents').onclick=onclick1;
	if (comm=="start") {
		//collapse widget
		if (!isCollapsed) {
			MouseClicked('',"middle",0,120);
			delay=2000;
		}
		//inform
		animTransTimerInform = setTimeout("updateFront(false,'"+comm+"','')",delay);
		//pull anchor
		animTransTimerAnchor = setTimeout("MoveElement(\"anchor\",20,71)",delay);
		//sail up
		animTransTimerSail = setTimeout("sailover()",delay+1500);
		//unblock clicking
		setTimeout("document.getElementById('top').onclick=onclick2",delay+2500);
		setTimeout("document.getElementById('bottom-contents').onclick=onclick2",delay+2500);
		//navigate
		//setTimeout("navigate(); animTransTimerNavigate = setInterval(\"navigate()\",7000)",delay+3000);		
	} else {
		//stop navigate
		//clearInterval(animTransTimerNavigate);
		//stop inform & pull anchor & sail up
		clearTimeout(animTransTimerInform);
		clearTimeout(animTransTimerAnchor);
		clearTimeout(animTransTimerSail);
		//inform
		updateFront(true,comm,status);
		setTimeout("updateFront(false,'')",30000);
		//sail out
		sailout();
		//anchor down
		MoveElement("anchor",20,71);
		setTimeout("document.getElementById('top').onclick=onclick2",3000);
		setTimeout("document.getElementById('bottom-contents').onclick=onclick2",3000);
	}
}

function navigate() {
	//wave rise
	waveover();
	//random move
	setTimeout("navigate_move()",300);
}

function navigate_move() {
	//random move
	var height = calculateBackgroundHeight();
	var width = calculateBackgroundWidth();
	randX=randomValue(2,7);
	randY=randomValue(1,3);
	moveMultiplier=15;
	if ((window.screenX-randX*moveMultiplier)<=0) signX=1; else if ((window.screenX+randX*moveMultiplier+width)>=screen.width) signX=-1; else signX=(randomValue(0,1)==1 ? 1 : -1);
	if ((window.screenY-randY*moveMultiplier)<=0) signY=1; else if ((window.screenY+randY*moveMultiplier+height)>=screen.height) signY=-1; else signY=(randomValue(0,1)==1 ? 1 : -1);
	randX*=signX;
	randY*=signY;
	for (i=1;i<=moveMultiplier;i++) {
		widget.resizeAndMoveTo(window.screenX+randX,window.screenY+randY,width,height);
		widget.setCloseBoxOffset (randX + 6, randY+86);
		widget.setPositionOffset (randX, randY);
	}
	//wave out
	setTimeout("waveout()",1000);
}

function hidePrefs() {
	MouseClicked(event,"middle",0,120);
}

/*################# animating "i" button ##################*/

var flipAnimation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};
var flipShown = false;

function flipAnimate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-flipAnimation.starttime, 0, flipAnimation.duration);
	
	if (T >= flipAnimation.duration)
	{
		clearInterval (flipAnimation.timer);
		flipAnimation.timer = null;
		flipAnimation.now = flipAnimation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / flipAnimation.duration));
		flipAnimation.now = computeNextFloat (flipAnimation.from, flipAnimation.to, ease);
	}
	
	flipAnimation.element.style.opacity = flipAnimation.now;
}

function MouseMoved (event,side)
{
	if (!flipShown)
	{
		// fade in the flip widget
		if (flipAnimation.timer != null)
		{
			clearInterval (flipAnimation.timer);
			flipAnimation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		flipAnimation.duration = 500;
		flipAnimation.starttime = starttime;
		if (side=="front") flipAnimation.element = document.getElementById ('flip'); else flipAnimation.element = document.getElementById ('flipback'); 
		flipAnimation.timer = setInterval ("flipAnimate();", 13);
		flipAnimation.from = flipAnimation.now;
		flipAnimation.to = 1.0;
		flipAnimate();
		flipShown = true;
	}
}

function MouseClicked(event,elem,from,to) 
{
	var midDiv = document.getElementById(elem);
	var timeNow = (new Date).getTime();
	var multiplier = (event.shiftKey ? 10 : 1); // enable slo-mo
	var startingSize = parseInt(midDiv.clientHeight,10);
	resizeAnimation.element = midDiv;
	if (resizeAnimation.timer != null) // it is moving... change to new size
	{
		clearInterval(resizeAnimation.timer);
		resizeAnimation.timer = null;
		resizeAnimation.duration -= (timeNow - resizeAnimation.startTime);
		resizeAnimation.positionFrom = resizeAnimation.positionNow;
	}
	else
	{
		resizeAnimation.duration = 250 * multiplier;
		resizeAnimation.positionFrom = startingSize;
	}
	isCollapsed = !isCollapsed;
	var resizeTo = isCollapsed ? from : to;
	totalWidgetHeight = calculateBackgroundHeight();
	if (!isCollapsed) {
		updateFront(false,"","");
		document.getElementById('serverinputlabel1line').style.visibility = "hidden";
		document.getElementById('serverinputlabel2line').style.visibility = "hidden";
		window.resizeTo (calculateBackgroundWidth(), totalWidgetHeight);
	}
	resizeAnimation.positionTo = parseInt(resizeTo); // lots of hard coding, yum...
	resizeAnimation.startTime = timeNow - 13; // set it back one frame.
	resizeAnimation.onfinished = animFinished(elem);
	
	resizeAnimation.element.style.height = startingSize;
	resizeAnimation.timer = setInterval ("animate('"+elem+"')", 13);
	animate(elem);	
}

function MoveElement(elem,from,to) 
{
	var midDiv = document.getElementById(elem);
	var timeNow = (new Date).getTime();
	var multiplier = 10; // enable slo-mo
	var startingSize = parseInt(midDiv.clientHeight,10);
	resizeAnimation.element = midDiv;
	if (resizeAnimation.timer != null) // it is moving... change to new size
	{
		clearInterval(resizeAnimation.timer);
		resizeAnimation.timer = null;
		resizeAnimation.duration -= (timeNow - resizeAnimation.startTime);
		resizeAnimation.positionFrom = resizeAnimation.positionNow;
	}
	else
	{
		resizeAnimation.duration = 250 * multiplier;
		resizeAnimation.positionFrom = startingSize;
	}
	isMoved = !isMoved;
	var resizeTo = isMoved ? from : to;
	totalWidgetHeight = calculateBackgroundHeight();
	if (!isMoved) {
		window.resizeTo (calculateBackgroundWidth(), totalWidgetHeight);
	}
	resizeAnimation.positionTo = parseInt(resizeTo); // lots of hard coding, yum...
	resizeAnimation.startTime = timeNow - 13; // set it back one frame.
	resizeAnimation.onfinished = animFinished(elem);
	
	resizeAnimation.element.style.height = startingSize;
	resizeAnimation.timer = setInterval ("animate('"+elem+"');", 13);
	animate(elem);	
}

function MouseExited (side)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (flipAnimation.timer != null)
		{
			clearInterval (flipAnimation.timer);
			flipAnimation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		flipAnimation.duration = 500;
		flipAnimation.starttime = starttime;
		if (side=="front") flipAnimation.element = document.getElementById ('flip'); else flipAnimation.element = document.getElementById ('flipback');
		flipAnimation.timer = setInterval ("flipAnimate();", 13);
		flipAnimation.from = flipAnimation.now;
		flipAnimation.to = 0.0;
		flipAnimate();
		flipShown = false;
	}
}

function EnterFlip(event,side)
{
	if (side=="front") 
	  document.getElementById('fliprollie').style.display = 'block'; 
  else 
    document.getElementById('fliprollieback').style.display = 'block';
}

function ExitFlip(event,side)
{
	if (side=="front") 
	  document.getElementById('fliprollie').style.display = 'none'; 
	else 
	  document.getElementById('fliprollieback').style.display = 'none';
}


/*################# animating sail ##################*/

var sailAnimation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};
var sailShown = false;

function sailAnimate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-sailAnimation.starttime, 0, sailAnimation.duration);
	
	if (T >= sailAnimation.duration)
	{
		clearInterval (sailAnimation.timer);
		sailAnimation.timer = null;
		sailAnimation.now = sailAnimation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / sailAnimation.duration));
		sailAnimation.now = computeNextFloat (sailAnimation.from, sailAnimation.to, ease);
	}
	
	sailAnimation.element.style.opacity = sailAnimation.now;
}

function sailover()
{
	if (!sailShown)
	{
		// fade in the sail
		if (sailAnimation.timer != null)
		{
			clearInterval (sailAnimation.timer);
			sailAnimation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		sailAnimation.duration = 500;
		sailAnimation.starttime = starttime;
		sailAnimation.element = document.getElementById ('sail-img');
		sailAnimation.timer = setInterval ("sailAnimate();", 13);
		sailAnimation.from = sailAnimation.now;
		sailAnimation.to = 1.0;
		sailAnimate();
		sailShown = true;
	}
}

function sailout()
{
	if (sailShown)
	{
		// fade in the sail
		if (sailAnimation.timer != null)
		{
			clearInterval (sailAnimation.timer);
			sailAnimation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		sailAnimation.duration = 500;
		sailAnimation.starttime = starttime;
		sailAnimation.element = document.getElementById ('sail-img');
		sailAnimation.timer = setInterval ("sailAnimate();", 13);
		sailAnimation.from = sailAnimation.now;
		sailAnimation.to = 0.0;
		sailAnimate();
		sailShown = false;
	}
}

/*################# animating wave ##################*/

var waveAnimation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};
var waveShown = false;

function waveAnimate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-waveAnimation.starttime, 0, waveAnimation.duration);
	
	if (T >= waveAnimation.duration)
	{
		clearInterval (waveAnimation.timer);
		waveAnimation.timer = null;
		waveAnimation.now = waveAnimation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / waveAnimation.duration));
		waveAnimation.now = computeNextFloat (waveAnimation.from, waveAnimation.to, ease);
	}
	
	waveAnimation.element.style.opacity = waveAnimation.now;
}

function waveover()
{
	if (!waveShown)
	{
		// fade in the wave
		if (waveAnimation.timer != null)
		{
			clearInterval (waveAnimation.timer);
			waveAnimation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		waveAnimation.duration = 500;
		waveAnimation.starttime = starttime;
		waveAnimation.element = document.getElementById ('wave-img');
		waveAnimation.timer = setInterval ("waveAnimate();", 13);
		waveAnimation.from = waveAnimation.now;
		waveAnimation.to = 1.0;
		waveAnimate();
		waveShown = true;
	}
}

function waveout()
{
	if (waveShown)
	{
		// fade in the wave
		if (waveAnimation.timer != null)
		{
			clearInterval (waveAnimation.timer);
			waveAnimation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		waveAnimation.duration = 500;
		waveAnimation.starttime = starttime;
		waveAnimation.element = document.getElementById ('wave-img');
		waveAnimation.timer = setInterval ("waveAnimate();", 13);
		waveAnimation.from = waveAnimation.now;
		waveAnimation.to = 0.0;
		waveAnimate();
		waveShown = false;
	}
}

/*################# widget events ##################*/

function WidgetLoaded() {

	// Set the text labels to proper localized fields

	document.getElementById('serverlabel').innerText = getLocalizedString('Server');
	document.getElementById('userlabel').innerText = getLocalizedString('User');
	document.getElementById('passlabel').innerText = getLocalizedString('Pass');
	document.getElementById('pathlabel').innerText = getLocalizedString('Path');
	document.getElementById('passivelabel').innerText = getLocalizedString('passive');

	// Load Preferences into Text Fields
	// In the case of protocol, since it may not be changed, save it outright

	if (window.widget)
	{
	
		var output = widget.system("GetAB cftp", null).outputString;
		//alert(output);
		if (output=="Y"+String.fromCharCode(10)) {
			cftpInstalled=true;
		} else {
			document.getElementById('backtext').innerHTML = "<B>CAPTAIN FTP<BR>IS NOT INSTALLED !</B><BR><A HREF='javascript:widget.openURL(\"http://www.versiontracker.com/dyn/moreinfo/mac/12941\")'>DOWNLOAD</A>";
			document.getElementById('backtextfade').innerHTML = document.getElementById('backtext').innerHTML;
		}
		
		output = widget.system("GetAB index", null).outputString;
		//var error = widget.system("GetAB index", null).errorString;
 		//var status = widget.system("GetAB index", null).status;
 		//document.getElementById('backtext').innerText = output+'#'+error+'#'+status;		
		var pop=0;
		var index=0;
		var i=0;
		var character=String.fromCharCode(10);
		var hostname;
		while (index<output.length) {
			pop=index;
			index=output.indexOf(character,index);
			if (index>-1) {
				hostname=output.substring(pop,index);
				if (hostname!='') {
				 	document.getElementById('serverinput2').length++;
					document.getElementById('serverinput2').options[document.getElementById('serverinput2').length-1].text=hostname;
				}
				index++;
			} else index=output.length;
		}
				
		pref = widget.preferenceForKey(createKey("server"));
		if (pref != null)
		{
			document.getElementById('serverinput').value = pref;
		}
		prefRetype(document.getElementById('serverinput'), 'server');

		pref = widget.preferenceForKey(createKey("user"));
		if (pref != null)
		{
			document.getElementById('userinput').value = pref;
		}
		prefRetype(document.getElementById('userinput'), 'user');

		pref = widget.preferenceForKey(createKey("pass"));
		if (pref != null)
		{
			document.getElementById('passinput').value = pref;
		}		
		prefRetype(document.getElementById('passinput'), 'pass');
		
		pref = widget.preferenceForKey(createKey("path"));
		if (pref != null)
		{
			document.getElementById('pathinput').value = pref;
		}
		prefRetype(document.getElementById('pathinput'), 'path');
		
		pref = widget.preferenceForKey(createKey("protocol"));
		if (pref != null)
		{
			document.getElementById('protocolinput').options.namedItem(pref).selected = true;
		} else {
			pref = "FTP";
			document.getElementById('protocolinput').options.namedItem(pref).selected = true;
			prefChanged(document.getElementById('protocolinput'), 'protocol');
		}
		prefRetype(document.getElementById('protocolinput'), 'protocol');
		
		pref = widget.preferenceForKey(createKey("passive"));
		if (pref != null)
		{
			(pref == 'Y' ? document.getElementById('passiveinput').checked = true : document.getElementById('passiveinput').checked = false);
		}
		prefRetype(document.getElementById('passiveinput'), 'passive');
		
	}
	
	createGenericButton(document.getElementById('done'), getLocalizedString('Done'), hidePrefs);
	updateFront(true,"","");
}

function updateFront(allowLocalized,trans,status) {
	if (trans=="start") {
		displayServer = getLocalizedString('uploading...');
		displayFolder = "";
	} else if (trans=="finish") {
		switch (status) {
			case "0": 
				displayServer = getLocalizedString('error');
				displayFolder = getLocalizedString('wrong parameters');
				break;
			case "1": 
				displayServer = getLocalizedString('error');
				displayFolder = getLocalizedString('cannot connect to server');
				break;
			case "2": 
				displayServer = getLocalizedString('error');
				displayFolder = getLocalizedString('transfer error');
				break;
			case "3": 
				displayServer = getLocalizedString('upload');
				displayFolder = getLocalizedString('successful');
				break;
		  case "4": 
				displayServer = getLocalizedString('error');
				displayFolder = getLocalizedString('Connection broken');
				break;
		  case "9":
		    displayServer = getLocalizedString('error');
		    displayFolder = getLocalizedString('Captain FTP has been closed');
			default: 
				displayServer = "???";
				displayFolder = "???";
				break;
		}
	} else {
		if (serverinput.value == "") {
			if (allowLocalized) displayServer = getLocalizedString('Not Configured'); else displayServer = "";
			displayFolder = "";
		} else {
			displayServer = (serverinput.value.length>25 ? serverinput.value.substring(0,22)+"..." : serverinput.value);
			displayFolder = (pathinput.value.length>25 ? "..."+pathinput.value.substring(pathinput.value.length-22,pathinput.value.length) : pathinput.value);
		}
	}
	document.getElementById('serverinputlabel1line').innerText = displayServer;
	document.getElementById('serverinputlabel2line').innerText = displayFolder;
}

if (window.widget) {
	widget.onremove = onremove;
	widget.onshow = onshow;
	widget.onhide = onhide;
}

function onremove () {
	if (window.widget) {
		widget.setPreferenceForKey (null, createKey("server"));
		widget.setPreferenceForKey (null, createKey("user"));
		widget.setPreferenceForKey (null, createKey("path"));
		widget.setPreferenceForKey (null, createKey("pass"));
		widget.setPreferenceForKey (null, createKey("protocol"));
		widget.setPreferenceForKey (null, createKey("passive"));
	}
}

function onshow () {
}

function onhide () {
}

/*############### uploading #################*/

function EndOfCmd ()
{
var status;
  if (cmdStatus.outputString) 
  {
    //alert(cmdStatus.outputString);
    status = cmdStatus.outputString;
    status = status.replace(/(\n)|(\r)/gi, "");
  }
  else
  {
    alert("No response from AppleScript.");
    status = "Unknown";  
  }
  
  cmdStatus = null;

	animTransmition("finish",status);
	
	if (status == "3") 
	{
    alert("Uploading finished successfully.");
	} 
	else
	{
	  if (status == "0") 
					alert("Wrong parameters.");
	  else if (status == "1")
					alert("Cannot connect to server.");
	  else if (status == "2")
					alert("Transfer error.");
		else if (status == "4")
					alert("Connection broken.");
		else if (status == "9")
					alert("Captain FTP has been closed.");
		else if (cftpInstalled)
		{
			document.getElementById('backtext').innerHTML = "<B>ERROR EXECUTING APPLESCRIPT !</B><BR><BR><BR><BR><BR><BR><BR><B>PLEASE TRY WITH<BR>THE NEWEST CAPTAIN FTP!</B><BR><BR><A HREF='javascript:widget.openURL(\"http://www.versiontracker.com/dyn/moreinfo/mac/12941\")'>DOWNLOAD</A>";		
			document.getElementById('backtextfade').innerHTML = document.getElementById('backtext').innerHTML;
			ShowBack("");
		}
	}
}

function UploadPaths (passive, server, user, pass, path, prot, files) 
{
  if (server == "")
    return;
    
  if (user == "")
    user = "_cftp_noval_";
  if (pass == "")
    pass = "_cftp_noval_";
  if (path == "")
    path = "_cftp_noval_";
     
  cmd = "\"./WidgetCFTPLauncher\" " +'"'+prot+'" '+'"'+passive+'" '+'"'+server+'" '+'"'+user+'" '+'"'+pass+'" '+'"'+path+'" ';

  for (var i = 0; i < files.length; i++) 
  {
    filePath = files[i];
    filePath = filePath.replace(/file\:\/\/localhost/gi, "");
    filePath = unescape(filePath);
    filePath = filePath.replace(/\\/g, "\\\\");
    filePath = filePath.replace(/"/g, "\\\"");
    cmd += '"'+filePath+'" ';
	}
	
	//alert("cmd:"+cmd);
	animTransmition("start","");
	cmdStatus = widget.system(cmd, EndOfCmd);
} 

/*################# drag & drop ##################*/

var transferGoing = null;
var resultLast = null;

function DragDidEnter (event) 
{
  if (! serverinput.value || (cmdStatus != null))
    event.dataTransfer.dropEffect = "none";

  event.stopPropagation();
  event.preventDefault();
}

function DragIsOver (event) 
{
  if (! serverinput.value || (cmdStatus != null))
	event.dataTransfer.dropEffect = "none";

  event.stopPropagation();
  event.preventDefault();
}

function DragDidLeave (event) 
{
  event.stopPropagation();
  event.preventDefault();
}

function DragDidDrop (event) 
{
	if (serverinput.value == "")
	  return; 

  var uri = null;
	
  try 
  {
    uri = event.dataTransfer.getData("text/uri-list");
  } 
  catch (ex) 
  {
    alert("Can't get paths.");
    return;
  }
  
  if (uri)
  {
    files = uri.split("\n");

    if (window.widget && serverinput.value)
      UploadPaths((passiveinput.value==1 ? 'Y' : 'N' ) , serverinput.value, userinput.value, passinput.value, pathinput.value, protocolinput.value, files);
  }
	
	event.stopPropagation();
	event.preventDefault();
}
